TRAININGGROUNDS_Config={}
TRAININGGROUNDS_Config.Keybinds={}
TRAININGGROUNDS_Config.Camera={}

--------------------------------------------------------------------------------
--
--	User-editable values.
--  Changes will not take effect until you /reload World of Warcraft.
--
--------------------------------------------------------------------------------

-- Default "W".  Your movement speed is normally 7 yards per second.
TRAININGGROUNDS_Config.Keybinds.MoveForward="W"

-- Default "S".  
-- In 3D mode, backtracking will cause you to move at reduced speed.
TRAININGGROUNDS_Config.Keybinds.MoveBackward="S"

-- Default "A".  In 3D mode, you will walk left while facing forward.  
-- "Keyboard turning" controls are not yet implemented.
TRAININGGROUNDS_Config.Keybinds.StrafeLeft="A"

-- Default "D".  In 3D mode, you will walk right while facing forward.
TRAININGGROUNDS_Config.Keybinds.StrafeRight="D"

-- Default 9.0.  Affects how quickly the 3D camera rotates as you move the mouse.
-- Adjust this value to match World of Warcraft.  Camera speed is also affected by screen size;
-- the smaller your screen, the faster the camera rotates.
TRAININGGROUNDS_Config.Camera.CameraSpeed=9.0

-- Default 0.35.  Affects how quickly the cursor drifts as you move the 3D camera.
-- Since this value directly affects mouse speed, it also acts as a multiplier to camera speed;
-- be sure to adjust CameraSpeed above after changing this value.
TRAININGGROUNDS_Config.Camera.MouseSpeed=0.35

-- Default 0.592.  Affects how quickly the 3D camera moves with you as you move away from the center of the arena.  
-- Adjust this value if you find you are drifting away from the center of the screen as you move around.
-- Camera drift is also affected by screen size and aspect ratio; adjust this number upwards when playing in windowed mode.
TRAININGGROUNDS_Config.Camera.CameraDriftMultiplier=0.592