
--/run DressUpModel:SetModel("spells/8fx_zuldazarraid_monk_flankingstrikes_stormplatform.m2")
--/run DressUpModel:SetModel("spells/8fx_zuldazarraid_monk_flankingstrikes_spiritplane.m2")
--/run DressUpModel:SetModel("spells/8fx_warfronts_stormempowered_impact.m2")
--/run DressUpModel:SetAnimation(0)

do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_JADEFIREMASTERS_Drawable_MSSFlash_Blue=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JADEFIREMASTERS_Drawable_MSSFlash_Blue
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false

		self.modelfilename="spells/8fx_zuldazarraid_monk_flankingstrikes_stormplatform.m2"		
		self.modelfileid=2451892		
		self.scale3D=0.5	--TODO: probably move to modelinfo
		self.positionmultiplier=0.95	--TODO: move to modelinfo
		self.zsortoffset3D=-0.5	--measured in yards.  TODO: move to modelinfo
		self.defaultanimation=0
	end
end

do
	local super=TRAININGGROUNDS_JADEFIREMASTERS_Drawable_MSSFlash_Blue
	TRAININGGROUNDS_JADEFIREMASTERS_Drawable_MSSFlash_Green=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JADEFIREMASTERS_Drawable_MSSFlash_Green
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.modelfilename="spells/8fx_zuldazarraid_monk_flankingstrikes_earthplatform.m2"	
		self.modelfileid=2451889				
	end
end

do
	local super=TRAININGGROUNDS_JADEFIREMASTERS_Drawable_MSSFlash_Blue
	TRAININGGROUNDS_JADEFIREMASTERS_Drawable_MSSFlash_Red=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_JADEFIREMASTERS_Drawable_MSSFlash_Red
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.modelfilename="spells/8fx_zuldazarraid_monk_flankingstrikes_fireplatform.m2"		
		self.modelfileid=2451890
	end
end


-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------
-------------------------------------------------------

do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_JADEFIREMASTERS_Decor_FlashTest=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JADEFIREMASTERS_Decor_FlashTest

	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.currentanim=0
	end
	
	function class:SetDrawable()
		-- set clonecounter BEFORE calling setup!
		if(self.clonecounter==1 or self.clonecounter==5)then
			self.drawable=TRAININGGROUNDS_JADEFIREMASTERS_Drawable_MSSFlash_Blue.new()
		elseif(self.clonecounter==2 or self.clonecounter==4)then
			self.drawable=TRAININGGROUNDS_JADEFIREMASTERS_Drawable_MSSFlash_Green.new()
		else
			self.drawable=TRAININGGROUNDS_JADEFIREMASTERS_Drawable_MSSFlash_Red.new()
		end
		self.drawable:Setup(self,self.environment)
		--self.drawable.frame:SetAnimation(2)
	end
	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.telegraphframelayer
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		if(self.alivetime==0)then
			self.drawable.frame:SetAnimation(127)
		elseif(self.alivetime>1.0 and self.currentanim~=159)then
			self.currentanim=159
			self.drawable.frame:SetAnimation(self.currentanim)
		elseif(self.alivetime>1.75)then
			self:Die()
		end
		--TODO: add BEFORE checking time (but requires better state machine check)
		self.alivetime=self.alivetime+elapsed
	end
	
	-- function class:Step()
		-- --!!!
		-- --self.drawable.frame:FreezeAnimation(2,.1500)
		
	-- end	
end