do
	local super=TRAININGGROUNDS_Mobile
	TRAININGGROUNDS_JAINA_Mobile_Jaina=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JAINA_Mobile_Jaina

	function class:GetName()
		--override, don't call super
		return "Jaina (mobile) "..tostring(self.id)
	end
	

	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.nameplatename="Jaina"
		self.basemovespeed = 1.5 * TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(7.0)
		self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*10.0
		--self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*4.0
		--self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*3.0
		--self.baseturnspeed=2.0	
		--self.baseturnspeed_3D=2.0	
		--self.faction=TRAININGGROUNDS_Factions.ENEMY
		
		--set after calling setup: 
		self.groupdancemodule=nil	-- (used when spells create further objects)		
	end
	
	function class:CreateAI()
		self.ai=TRAININGGROUNDS_AI_Boss.new()
		self.ai:Setup(self,environment)
	end		
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_JAINA_Drawable_Jaina.new()
		self.drawable:Setup(self,self.environment)
	end
	
	-- function class:CreateCombatModule()
		-- self.combat=TRAININGGROUNDS_JAINA_CombatModule_Jaina.new()
		-- self.combat:Setup(self)
	-- end
end

do
	--TODO: move to content/aggramar
	TRAININGGROUNDS_JAINA_ANIMATION_LIST={}


	-- local stand=TRAININGGROUNDS_AnimationSequence_QuickSetup(TRAININGGROUNDS_JAINA_ANIMATION_LIST,"Stand",0,nil,TRAININGGROUNDS_ANIMATION_PRIORITY.TELEGRAPH,nil)	
	-- local stance=TRAININGGROUNDS_AnimationSequence_QuickSetup(TRAININGGROUNDS_JAINA_ANIMATION_LIST,"Stance",51,nil,TRAININGGROUNDS_ANIMATION_PRIORITY.TELEGRAPH,nil)
	-- local loop=TRAININGGROUNDS_AnimationSequence_QuickSetup(TRAININGGROUNDS_JAINA_ANIMATION_LIST,"Jaina",125,nil,TRAININGGROUNDS_ANIMATION_PRIORITY.TELEGRAPH,nil)
	


	if(not TRAININGGROUNDS_ModelInfos.Jaina)then
		local mi
		mi=TRAININGGROUNDS_ModelInfo.new()
		mi:Setup()
		mi.displayid=87892
		mi.cameradistance=15
		mi.size=150
		mi.shadowsize=mi.size*0.75
		
		mi.clickboxx=0
		mi.clickboxy=-5
		mi.clickboxwidth=32
		mi.clickboxheight=52
		
		TRAININGGROUNDS_ModelInfos.Jaina=mi
		TRAININGGROUNDS_ModelInfos:Add(mi.displayid,mi)
	end

	local super=TRAININGGROUNDS_Drawable_CharacterModel
	TRAININGGROUNDS_JAINA_Drawable_Jaina = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_JAINA_Drawable_Jaina 
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.scale3D=1.5	--TODO: move to modelinfo
		--self.positionmultiplier=0.9
		self.positionmultiplier=1/self.scale3D
	end
	
	function class:SetFrameAppearance()	
		self.modelinfo=TRAININGGROUNDS_ModelInfos.Jaina
		self.frame:SetDisplayInfo(self.modelinfo.displayid)	
	end
	
	-- function class:Get3DPositionCoords()
		-- local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
		-- return self.x,self.y,self.z+yard*0.25
	-- end
end

----------------------------------
----------------------------------
----------------------------------
----------------------------------
----------------------------------

