do

	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	local REDX="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7:12\124t"
	local INTRO_TIME_MULTIPLIER=1.0

	TRAININGGROUNDS_MEKKATORQUE_CustomDanceEventType={}
	local i=0
	i=i+1;TRAININGGROUNDS_MEKKATORQUE_CustomDanceEventType.SUCCESS=i
	i=i+1;TRAININGGROUNDS_MEKKATORQUE_CustomDanceEventType.HIT_BY_BUSTERCANNON=i
	i=i+1;TRAININGGROUNDS_MEKKATORQUE_CustomDanceEventType.HIT_BY_SPARKPULSE=i

	
	local super=TRAININGGROUNDS_GroupDanceModule	
	TRAININGGROUNDS_MEKKATORQUE_GroupDanceModule_Mekkatorque=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_MEKKATORQUE_GroupDanceModule_Mekkatorque
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.successesinarow=0
		self.previous_mode_choice=2	--distractions OFF
		self.mode_choice=nil
		self.playerisdead=false
		self.sparkbots={}
	end


	
	function class:PopulateDefaultRaid(environment)	
		self.environment=environment

		self.mekkatorque=self.bosscontroller.mekkatorque	
		self.mekkatorque.groupdancemodule=self
	

		self.raid:CreatePlayers(environment,2,5,6,8)
		--self.raid:MakeAllPlayersIrrelevant()
		
		-- -- for now, no autocasts.
		-- for i=1,#self.raid.players do
			-- self.raid.players[i].combat.autocastmodule:Cleanup()
			-- self.raid.players[i].combat.autocastmodule=nil
		-- end
	
		--TODO: move raid roles to another function
		self.tanks=self.raid.tanks
		self.currenttankindex=1
		self.rdps=self.raid.rdps
		self.player=self.raid.rdps[1]

		
		--self.centercircles={}
		

		
		-- local platformsize=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(100)		
		-- --TODO: arenaborder should be in baseline scenario class
		-- local bigcircle=TRAININGGROUNDS_BigCircle.new()
		-- bigcircle:Setup(self.environment.game.environment_gameplay)
		-- bigcircle.drawable.width=platformsize+20
		-- bigcircle.drawable.height=platformsize+20
		-- bigcircle.x=0
		-- bigcircle.y=0
		-- bigcircle.drawable:SetColor(.5,.75,1,1)		
		-- local bigcircle=TRAININGGROUNDS_BigCircle.new()
		-- bigcircle:Setup(self.environment.game.environment_gameplay)
		-- bigcircle.drawable.width=platformsize
		-- bigcircle.drawable.height=platformsize
		-- bigcircle.x=0
		-- bigcircle.y=0	
		-- bigcircle.drawable:SetColor(.375,.625,1,1)
		
		
		for i=1,3 do																				
			local sparkbot=TRAININGGROUNDS_MEKKATORQUE_SparkBot_Mobile.new()
			sparkbot:Setup(self.environment)
			sparkbot.groupdancemodule=self
			local angle=math.random()*math.pi*2
			local dist=yard*4*math.random()
			sparkbot.x=-yard*5+math.cos(angle)*dist
			sparkbot.y=0+math.sin(angle)*dist
			sparkbot.nextsparkpulsetime=self.scenario.localtime+math.random()*5
			tinsert(self.sparkbots,sparkbot)
		end
		

							
		self:SetupInitialCameraFocus()
	end
	
	--TODO: maybe baseline, maybe not
	function class:SetupInitialCameraFocus()
		local camera=self.player.environment.cameramanager.camera
		tinsert(camera.focus,self.player)
	end

	
	function class:GetIntoInitialPosition()							
		self.mekkatorque.x=yard*0
		self.mekkatorque.y=yard*0
	
		--TODO: staggered autocast so the animations aren't perfectly synced up
	
		for i=1,#self.raid.mdps do
			local raider=self.raid.mdps[i]
			local offsetangle=math.random()*math.pi*2
			local offsetdist=math.random()*yard*2			
			raider.x=0+offsetdist*math.cos(offsetangle)
			raider.y=yard*-2+offsetdist*math.sin(offsetangle)
			--raider.combat.targetcombat=self.mekkatorque.combat;raider.ai:StartAutoCasting()			
		end	
		for i=1,#self.raid.healers do
			local raider=self.raid.healers[i]
			local offsetangle=math.random()*math.pi*2
			local offsetdist=math.random()*yard*2			
			raider.x=0+offsetdist*math.cos(offsetangle)
			raider.y=yard*-12+offsetdist*math.sin(offsetangle)
			--raider.combat.targetcombat=self.mekkatorque.combat;raider.ai:StartAutoCasting()
		end	
		for i=1,#self.raid.rdps do
			local raider=self.raid.rdps[i]
			local offsetangle=math.random()*math.pi*2
			local offsetdist=math.random()*yard*2			
			raider.x=yard*-5+offsetdist*math.cos(offsetangle)
			raider.y=yard*-15+offsetdist*math.sin(offsetangle)	
			--raider.combat.targetcombat=self.mekkatorque.combat;raider.ai:StartAutoCasting()
		end	
		for i=1,#self.raid.tanks do
			local raider=self.raid.tanks[i]
			raider.x=yard*4
			raider.y=yard*1*((i-1)*2-1)
			--raider.combat.targetcombat=self.mekkatorque.combat;raider.ai:StartAutoCasting()
		end
		
		self:SparkBotsAway()
		
		self.player.x=0
		self.player.y=yard*-12
		--self.player.y=0--!!!
		self.player.currentfacing=math.pi/2	-- facing "north" for 3D camera
		--self.player.currentfacing_3D=self.player.currentfacing
		--self.player.targetfacing_3D=self.player.currentfacing
		self.scenario.environment.game.environment_gameplay.cameramanager.camera.cangy=self.player.currentfacing

		-- --!!!
		-- self.floor.x=self.player.x
		-- self.floor.y=self.player.y
		-- self.scenario.TEMPfloor=self.floor
		self.scenario.player=self.player
		self.player.groupdancemodule=self
		

		for i=1,#self.raid.players do
			self.raid.players[i]:SnapFacingToTargetMobile(self.mekkatorque)
			if(self.raid.players[i]~=self.player)then self.raid.players[i].visible=false end
		end
		self.mekkatorque:SnapFacingToTargetMobile(self.raid.tanks[1])



		
	end
	
	function class:StartDancing()
		-- TODO: for some reason we're not using this function when we really should be
	end
	
	function class:StartTestCycle()
		self:ResetPlayerDeathChecks()
		local totaltime=0

		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+0.25
		event.time=self.scenario.localtime+totaltime	
		event.execute=function() 
			self:ResetPlayerDeathChecks()			

			self.mekkatorque.drawable:SetAnimation(TRAININGGROUNDS_ANIMATION_LIST.ReadyUnarmed)				
		end
		tinsert(self.timedevents,event)	
		
		
		if(self.mode_choice~=self.previous_mode_choice)then
			--allow 3 seconds to build up/clear up spell effect clutter
			totaltime=totaltime+3.0
		end
		self.previous_mode_choice=self.mode_choice

		if(self.mode_choice==1)then	--distractions ON
			for i=1,#self.raid.players do
				local raider=self.raid.players[i]
				if(raider~=self.player)then
					raider.visible=true
					local event=TRAININGGROUNDS_TimedDanceEvent.new()
					local offset=math.random()*3.0
					event.time=self.scenario.localtime+offset
					event.execute=function()
									raider.combat.targetcombat=self.mekkatorque.combat;raider.ai:StartAutoCasting()
								end;tinsert(self.timedevents,event)
				end
			end			
		else	--distractions OFF
			for i=1,#self.raid.players do
				local raider=self.raid.players[i]
				if(raider~=self.player)then
					raider.visible=false
					raider.ai:StopAutoCasting()
				end
			end
		end
		
		-- local event=TRAININGGROUNDS_TimedDanceEvent.new()
		-- totaltime=totaltime+0.25
		-- event.time=self.scenario.localtime+totaltime	
		-- event.execute=function() 
			-- local angle=math.atan2(self.player.y,self.player.x)
			-- local offset=math.random()*math.pi/4-math.pi/8
			-- --angle=angle+offset			
			-- --angle=-math.pi/2
			-- offset=0
			-- self.mekkatorque.targetfacing_3D=TRAININGGROUNDS_Atan2Modulo(angle+offset)			
			-- self.mekkatorque.drawable:SetAnimation(TRAININGGROUNDS_ANIMATION_LIST.ChannelCastDirected)
		-- end
		-- tinsert(self.timedevents,event)		
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+0.25
		event.time=self.scenario.localtime+totaltime
		event.execute=function() 																
				self:SparkBotsToward()
			end;tinsert(self.timedevents,event)				
		
		--2.8 second cast time, apparently
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+0.25
		event.time=self.scenario.localtime+totaltime
		event.execute=function() 														
							TEMP_CastSpellOnTargetMobile(self.mekkatorque,TRAININGGROUNDS_MEKKATORQUE_BusterCannon_Spell,nil)
							self:BusterCannonEmote()
						end;tinsert(self.timedevents,event)				
		
	
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+2.8
		totaltime=totaltime+1
		event.time=self.scenario.localtime+totaltime
		event.execute=function() 																					
							self.mekkatorque.targetfacing_3D=math.atan2(self.raid.tanks[1].y,self.raid.tanks[1].x)
						end;tinsert(self.timedevents,event)		
						
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+0.5
		event.time=self.scenario.localtime+totaltime
		event.execute=function() 																					
							--self.mekkatorque.drawable:SetAnimation(TRAININGGROUNDS_ANIMATION_LIST.ReadyUnarmed)
							self.mekkatorque.drawable:StopSpellcast()
						end;tinsert(self.timedevents,event)		


								
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+3.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 		
				self.mekkatorque.drawable.animationsystem:ClearAnimationByCategory(TRAININGGROUNDS_ANIMATION_PRIORITY.STANCE)
				self.scenario:ShowButtons()
				self:SparkBotsAway()
			end
			tinsert(self.timedevents,event)
		end				


	end
	
	
	
	function class:ResetPlayerDeathChecks()
		self.playerisdead=false
	end
	
	function class:SparkBotsAway()
		for i=1,#self.sparkbots do
			local sparkbot=self.sparkbots[i]
			sparkbot.ai:SetTargetLocationAndPrecision({x=yard*-15,y=0},yard*4)
		end
	end
	
	function class:SparkBotsToward()
		self:OneSparkBotToward(self.sparkbots[1],yard*0,yard*0)
		self:OneSparkBotToward(self.sparkbots[2],yard*0,yard*-12)
		self:OneSparkBotToward(self.sparkbots[3],yard*5,yard*-15)
	end
	
	function class:OneSparkBotToward(sparkbot,x,y)
		--local offsetangle=math.random()*math.pi*2
		--local offsetdist=math.random()*yard*4
		--local targetx=x+math.cos(offsetangle)*offsetdist
		--local targety=y+math.sin(offsetangle)*offsetdist
		local targetx=x
		local targety=y
		-- unit vector...
		local xdist=targetx-sparkbot.x
		local ydist=targety-sparkbot.y
		local uvdist=math.sqrt(xdist*xdist+ydist*ydist)		
		local uvx=xdist/uvdist
		local uvy=ydist/uvdist
		-- now march 25-75% of the total distance towards target to simulate rootbreak/reroot		
		local distratio=0.25+0.5*math.random()
		--TODO: we don't actually need unit vector here, uvx*uvdist=xdist
		--sparkbot.ai:SetTargetLocationAndPrecision({x=sparkbot.x+uvx*distratio,y=sparkbot.y+uvy*distratio},yard*0)
		sparkbot.ai:SetTargetLocationAndPrecision({x=sparkbot.x+uvx*distratio*uvdist,y=sparkbot.y+uvy*distratio*uvdist},yard*4)
	end
		
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		
		--print(self.localtime)
		for i=#self.timedevents,1,-1 do
			local event=self.timedevents[i]
			if(self.localtime>=event.time)then	
				event.execute()
				tremove(self.timedevents,i)
			end
		end
	end
		
	function class:ReactToCustomDanceEvent(event)
		if(event.action==TRAININGGROUNDS_MEKKATORQUE_CustomDanceEventType.HIT_BY_BUSTERCANNON)then
			self.playerisdead=true
			self.player.combat:FlashDamageFlash_Alert()
		elseif(event.action==TRAININGGROUNDS_MEKKATORQUE_CustomDanceEventType.HIT_BY_SPARKPULSE)then
			self.playerisdead=true
			self.player.combat:FlashDamageFlash_Alert()
		end		
	end


	function class:BusterCannonEmote()
		if(self.mode_choice==1)then	-- distractions ON
			local iconsize="20"
			local icon="\124Tinterface\\icons\\spell_mage_flameorb_blue:"..iconsize.."\124t"
			local link="\124cffff0000\124Hspell:282182\124h[Buster Cannon]\124h\124r"			
			local message=icon..""..link.." — dodge attack"
			TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,1.0,true)		
		end
	end

	
	
	
	function class:GetEndOfCycleDelay()
		return 3.0
	end
	
	--TODO: cleanup (and cleanup on base groupdancemodule too?)
	function class:Cleanup()
		--TODO: NYI
	end
end
