--TODO: <s>when shield is hit, instead of calling Die(), setanimation 159 and set expirytime</s>
--TODO: instead of setanimation159, arcane explosion effect on shield hit?
--TODO: visible spear projectile
--TODO: fade in/fade out for enemies?

do

	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	local REDX="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7:12\124t"
	local INTRO_TIME_MULTIPLIER=1.0

	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_VOLTAICFLASH_CustomDanceEventType={}
	local i=0
	i=i+1;TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_VOLTAICFLASH_CustomDanceEventType.SUCCESS=i
	i=i+1;TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_VOLTAICFLASH_CustomDanceEventType.HIT_BY_VOLTAICFLASH=i	

	
	local super=TRAININGGROUNDS_GroupDanceModule	
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_GroupDanceModule_ChargedSpear=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_GroupDanceModule_ChargedSpear
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.successesinarow=0
		self.mode_choice=nil
		self.playerisdead=false
		self.shieldsuccess=false
		self.solidfailure=false
	end


	
	function class:PopulateDefaultRaid(environment)	
		self.environment=environment

		--self.azshara=self.bosscontroller.azshara	
		--self.azshara.groupdancemodule=self
	

		self.raid:CreatePlayers(environment,0,0,0,1)
		self.raid:MakeAllPlayersIrrelevant()
		
		--TOdo: move raid roles to another function
		self.tanks=self.raid.tanks
		self.rdps=self.raid.rdps
		self.player=self.raid.rdps[1]

							
		self:SetupInitialCameraFocus()
	end
	
	--TOdo: maybe baseline, maybe not
	function class:SetupInitialCameraFocus()
		local camera=self.player.environment.cameramanager.camera
		tinsert(camera.focus,self.player)
	end

	
	function class:GetIntoInitialPosition()							
		--self.azshara.x=yard*0
		--self.azshara.y=yard*0
	
		
		self.player.x=yard*-6
		self.player.y=yard*-12
		--self.player.y=0--!!!
		self.player.currentfacing=math.pi*.35
		self.player.currentfacing_3D=self.player.currentfacing
		self.player.targetfacing_3D=self.player.currentfacing
		self.scenario.environment.game.environment_gameplay.cameramanager.camera.cangy=self.player.currentfacing

		-- --!!!
		-- self.floor.x=self.player.x
		-- self.floor.y=self.player.y
		-- self.scenario.TEMPfloor=self.floor
		self.scenario.player=self.player
		self.player.groupdancemodule=self
		



		
	end
	
	function class:StartDancing()
		-- TOdo: for some reason we're not using this function when we really should be
	end
	
	function class:StartTestCycle()
		self:ResetPlayerDeathChecks()
		local totaltime=0

		self.shieldposition=math.random(2)	-- 1 console, 2 pillar
		self.sidetidemistressposition=(math.random(2)-1)*2-1	-- -1 left, 1 right
		self.tidemistresses={}
		local tidemistress=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Tidemistress_Mobile.new()		
		tidemistress:Setup(self.environment.game.environment_gameplay)	
		tidemistress.x=0;tidemistress.y=-yard*30		
		tidemistress.currentfacing=-math.pi/2	--"south"
		tinsert(self.tidemistresses,tidemistress)
		local tidemistress=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Tidemistress_Mobile.new()		
		tidemistress:Setup(self.environment.game.environment_gameplay)	
		tidemistress.x=self.sidetidemistressposition*yard*22.5;tidemistress.y=yard*7.5		
		--tidemistress.x=0;tidemistress.y=yard*7.5		
		tidemistress.currentfacing=-math.pi/2	--"south"
		tinsert(self.tidemistresses,tidemistress)
		
		local shield=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_CrystallineShield_Decor.new()
		shield:Setup(self.environment.game.environment_gameplay)
		if(self.shieldposition==1)then
			shield.x=0;shield.y=-yard*30
		else
			shield.x=self.sidetidemistressposition*yard*22.5;shield.y=yard*7.5	
		end
		self.shield=shield
		
		local myrmidon=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_LoyalMyrmidon_Mobile.new()
		myrmidon:Setup(self.environment.game.environment_gameplay)
		if(self.shieldposition==1)then
			myrmidon.x=-self.sidetidemistressposition*yard*5;myrmidon.y=-yard*30
		else
			myrmidon.x=self.sidetidemistressposition*yard*23.5;myrmidon.y=yard*2.5	
		end
		self.myrmidon=myrmidon
		
		local azshara=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Azshara_Mobile.new()
		azshara:Setup(self.environment.game.environment_gameplay)
		--local offsetdist=yard*2--yard*(math.random(5)+5)
		--local offsetangle=math.random()*math.pi*2
		--local offsetx=math.cos(offsetangle)*offsetdist
		--local offsety=math.sin(offsetangle)*offsetdist
		--azshara.x=myrmidon.x+offsetx;azshara.y=myrmidon.y+offsety
		local xdiff=self.shield.x-self.myrmidon.x
		local ydiff=self.shield.y-self.myrmidon.y	
		azshara.x=self.myrmidon.x-xdiff
		azshara.y=self.myrmidon.y-ydiff
		azshara.currentfacing=math.atan2(shield.y-azshara.y,shield.x-azshara.x)
		self.azshara=azshara
		
		
		self.azshara.combat:ApplyAuraByClass(TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Aura_FadeIn,self.azshara.combat)
		self.myrmidon.combat:ApplyAuraByClass(TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Aura_FadeIn,self.myrmidon.combat)
		self.tidemistresses[1].combat:ApplyAuraByClass(TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Aura_FadeIn,self.tidemistresses[1].combat)
		self.tidemistresses[2].combat:ApplyAuraByClass(TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Aura_FadeIn,self.tidemistresses[2].combat)
		
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+0.25
		event.time=self.scenario.localtime+totaltime	
		event.execute=function() 
			self:ResetPlayerDeathChecks()			
		end
		tinsert(self.timedevents,event)	

		totaltime=totaltime+0.25			
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		event.time=self.scenario.localtime+totaltime
		if(totaltime>0)then
			event.execute=function() 						
				if(self.mode_choice==1)then
					local ghost=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_HintGhost_Mobile.new()
					ghost:Setup(self.environment.game.environment_gameplay)
					ghost.x=self.player.x;ghost.y=self.player.y				
					ghost.currentfacing=self.player.currentfacing								
					--local xdiff=self.shield.x-self.myrmidon.x
					--local ydiff=self.shield.y-self.myrmidon.y															
					--ghost.ai:SetTargetLocationAndPrecision({x=self.shield.x+xdiff,y=self.shield.y+ydiff},0)
					ghost.ai:SetTargetLocationAndPrecision({x=yard*22.5*self.sidetidemistressposition,y=-yard*27},0)
					ghost.combat:ApplyAuraByClass(TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Aura_HintGhost, ghost.combat)
					self.ghost=ghost							
				end
			end;tinsert(self.timedevents,event)			
		end		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+2.0
		event.time=self.scenario.localtime+totaltime
		if(totaltime>0)then
			event.execute=function() 
				local target
				if(self.shieldposition==1)then target="CONSOLE" else target="PILLAR" end
				local message="Break the \124cffff0000"..target.."\124r Tidemistress's shield."				
				TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,1.0,true)		
			end;tinsert(self.timedevents,event)	
		end
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+2.0
		event.time=self.scenario.localtime+totaltime
		if(totaltime>0)then
			event.execute=function() 		
				if(self.mode_choice==1)then
					local xdiff=self.shield.x-self.myrmidon.x
					local ydiff=self.shield.y-self.myrmidon.y															
					self.ghost.ai:SetTargetLocationAndPrecision({x=self.shield.x+xdiff,y=self.shield.y+ydiff},0)				
				end		
			end;tinsert(self.timedevents,event)	
		end
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+4.0
		event.time=self.scenario.localtime+totaltime
		if(totaltime>0)then
			event.execute=function() 
				local iconsize="20"
				local icon="\124Tinterface\\icons\\inv_polearm_2h_odynspear_d_01:"..iconsize.."\124t"
				local link="\124cffff0000\124Hspell:298425\124h[Charged Spear]\124h\124r"			
				local message=icon.."The Loyal Myrmidon aims a "..link.." at you!"				
				TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,1.0,true)		
				local timer=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_ChargedSpearTimer.new()
				timer:Setup(self.environment.game.environment_hud)
				--timer:Setup(self.environment)
				timer.x=-25-50+self.environment.game.SCREEN_WIDTH
				timer.y=-100-25+self.environment.game.SCREEN_HEIGHT		
				--self.myrmidon.drawable:SetAnimationByNumber(14)
			end;tinsert(self.timedevents,event)	
		end		
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+4.5
		event.time=self.scenario.localtime+totaltime
		if(totaltime>0)then
			event.execute=function()
				self.myrmidon.drawable:SetAnimationByNumber(16)
			end;tinsert(self.timedevents,event)	
		end

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+0.5
		event.time=self.scenario.localtime+totaltime
		if(totaltime>0)then
			event.execute=function() 
				--self.myrmidon.drawable:SetAnimationByNumber(17)
				-- spear toss...
				local xdist=self.player.x-self.myrmidon.x
				local ydist=self.player.y-self.myrmidon.y
				local dist=math.sqrt(xdist*xdist+ydist*ydist)
				local unitvectorx=xdist/dist
				local unitvectory=ydist/dist
				local x1,y1=self.myrmidon.x,self.myrmidon.y
				local x2,y2=x1+unitvectorx*yard*100,y1+unitvectory*yard*100
				local pillar1=TRAININGGROUNDS_LineCircleCollision(x1,y1,x2,y2,self.scenario.azshara.statues[1].x,self.scenario.azshara.statues[1].y,yard*6)
				local pillar2=TRAININGGROUNDS_LineCircleCollision(x1,y1,x2,y2,self.scenario.azshara.statues[2].x,self.scenario.azshara.statues[2].y,yard*6)
				local shield=TRAININGGROUNDS_LineCircleCollision(x1,y1,x2,y2,self.shield.x,self.shield.y,yard*3)				
				if(shield)then
					--TODO: shield explosion visual
					self.shield:Die()
					local explosion=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_CrystallineShieldExplosion_Decor.new()
					explosion:Setup(self.environment.game.environment_gameplay)
					explosion.x=self.shield.x;explosion.y=self.shield.y
					self.shieldsuccess=true
				end
				--TODO: console hit detection
				local console=TRAININGGROUNDS_LineRectangleCollision(x1,y1,x2,y2,
								self.scenario.azshara.console.x-yard*6.5,self.scenario.azshara.console.y-yard*3.5,
								self.scenario.azshara.console.x+yard*6.5,self.scenario.azshara.console.y+yard*3.5)
				if(pillar1 or pillar2 or console)then
					self.solidfailure=true
				end
				--print("Console:",console)
				
				
				-- spear visual
				local spear=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_ChargedSpear_Projectile.new()								
				spear:Setup(self.environment.game.environment_gameplay)				
				spear.x=self.myrmidon.x;spear.y=self.myrmidon.y
				spear.z=yard*2
				spear.currentfacing=math.atan2(unitvectory,unitvectorx)
				spear.xspeed=unitvectorx*yard*40
				spear.yspeed=unitvectory*yard*40
				
				--TODO: expirytime
				--spear.expirytime=
				
				
				
			end;tinsert(self.timedevents,event)	
		end		
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+3.0
		event.time=self.scenario.localtime+totaltime
		if(totaltime>0)then
			event.execute=function() 		
				local message
				if(self.solidfailure)then
					message="The spear hit something solid and exploded, wiping the raid!  Try again..."
				elseif(self.shieldsuccess==false)then
					message="The spear missed.  Try again..."
				else
					message="The shield vanished!  Success!"
				end
				TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,2.0,true)
			end
			tinsert(self.timedevents,event)
		end
		
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+1.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 
				self.azshara.combat:ApplyAuraByClass(TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Aura_FadeOut,self.azshara.combat)
				self.myrmidon.combat:ApplyAuraByClass(TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Aura_FadeOut,self.myrmidon.combat)
				self.tidemistresses[1].combat:ApplyAuraByClass(TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Aura_FadeOut,self.tidemistresses[1].combat)
				self.tidemistresses[2].combat:ApplyAuraByClass(TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Aura_FadeOut,self.tidemistresses[2].combat)
			end;tinsert(self.timedevents,event)
		end
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+2.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 	
				self.azshara:Die()
				self.tidemistresses[1]:Die()
				self.tidemistresses[2]:Die()
				self.myrmidon:Die()
				self.shield:Die()
				if(self.ghost)then self.ghost:Die() end
				
				self.scenario:ShowButtons()
			end
			tinsert(self.timedevents,event)
		end	


	end
	
	
	
	function class:ResetPlayerDeathChecks()
		self.playerisdead=false
		self.shieldsuccess=false
		self.solidfailure=false
	end
	

	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		--print(DECORFLOOR.x,DECORFLOOR.y,DECORFLOOR.z)
		--print(self.localtime)
		for i=#self.timedevents,1,-1 do
			local event=self.timedevents[i]
			if(self.localtime>=event.time)then	
				event.execute()
				tremove(self.timedevents,i)
			end
		end
		
		if(self.myrmidon and self.player)then
			self.myrmidon.currentfacing=math.atan2(self.player.y-self.myrmidon.y,self.player.x-self.myrmidon.x)
		end
	end
		
	function class:ReactToCustomDanceEvent(event)
		if(event.action==TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_VOLTAICFLASH_CustomDanceEventType.HIT_BY_VOLTAICFLASH)then
			self.lightninghits=self.lightninghits+1
			self.player.combat:FlashDamageFlash_Alert()		
		end		
	end




	
	
	
	function class:GetEndofCycleDelay()
		return 3.0
	end
	
	--TOdo: cleanup (and cleanup on base groupdancemodule too?)
	function class:Cleanup()
		--TOdo: NYI
	end
end
