do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_STORMWALLBLOCKADE_Decor_Laminaria=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Decor_Laminaria
	
	-- function class:SetCustomInfo()
		-- super.SetCustomInfo(self)
		-- self.ysortable=true
	-- end

	function class:GetName()
		--override, don't call super
		return "Laminaria (decor) "..tostring(self.id)
	end
	
	function class:CreateAI()
		self.ai=TRAININGGROUNDS_AI_Boss.new()
		self.ai:Setup(self,environment)
	end		
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_STORMWALLBLOCKADE_Drawable_Laminaria.new()
		self.drawable:Setup(self,self.environment)		
	end
	
	-- function class:CreateCombatModule()
		-- self.combat=TRAININGGROUNDS_STORMWALLBLOCKADE_CombatModule_Laminaria.new()
		-- self.combat:Setup(self)
	-- end
end

do


	if(not TRAININGGROUNDS_ModelInfos.Laminaria)then
		local mi
		mi=TRAININGGROUNDS_ModelInfo.new()
		mi:Setup()
		mi.displayid=90322
		--mi.cameradistance=80
		mi.cameradistance=40
		mi.size=1000
		TRAININGGROUNDS_ModelInfos.Laminaria=mi
		TRAININGGROUNDS_ModelInfos:Add(mi.displayid,mi)
	end

	local super=TRAININGGROUNDS_Drawable_CharacterModel
	TRAININGGROUNDS_STORMWALLBLOCKADE_Drawable_Laminaria = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Drawable_Laminaria 
	
	function class:SetFrameLayer()
		-- it turns out laminaria is short enough that we don't need to worry about them appearing in front of the floor.
		-- their hands should appear in front of EVERYTHING, though
			-- TODO: don't use nameplateframelayer
		self.framelayer=self.owner.environment.cameramanager.nameplateframelayer
	end
	
	function class:SetFrameAppearance()	
		self.modelinfo=TRAININGGROUNDS_ModelInfos.Laminaria
		self.frame:SetDisplayInfo(self.modelinfo.displayid)	
	end

end
