local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)

local ghostalpha=1.0
local ghostAA=10.0
local ghost_low=0.0
local ghost_med=0
local ghost_high=1
do
	local super=TRAININGGROUNDS_Aura_Visual_ModelLighting
	TRAININGGROUNDS_STORMWALLBLOCKADE_Aura_StormsWail=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Aura_StormsWail
	
	function class:SetupNewauraLists(auramodule)
		super.SetupNewauraLists(self,auramodule)	
		tinsert(self.auramodulelists,auramodule.visual_modelalpha)
		----since we're inheriting modellighting, we don't need to tinsert it again
		--tinsert(self.auramodulelists,auramodule.visual_modellighting)
	end	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.lightAA=ghostAA
		self.lightAR=ghost_low
		self.lightAG=ghost_med
		self.lightAB=ghost_high
		self.lightDA=0
		self.lightDR=ghost_low
		self.lightDG=ghost_med
		self.lightDB=ghost_high
		self.desat=1.0
		self.alpha=ghostalpha
	end	
	-- since we're not inheriting modelalpha, we have to redefine GetAlpha here
	--TODO: fix things so we don't have to redefine GetAlpha here
	function class:GetAlpha()
		return self.alpha
	end		
end


do
	local super=TRAININGGROUNDS_Sprite
	TRAININGGROUNDS_STORMWALLBLOCKADE_Sprite_StormsWailTimer=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Sprite_StormsWailTimer
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_Drawable_Sprite.new()		
		self.drawable:Setup(self,self.environment)
		self.drawable.ystretch=false
		self.drawable.width=100
		self.drawable.height=100	
		self.drawable.frame.texture:Show()
		self.drawable.frame.texture:SetTexture("interface\\icons\\spell_nature_lightningoverload.blp")
		self.drawable.frame.fontstring:Show()
		self.drawable.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",48,"OUTLINE")
		self.drawable.frame.fontstring:SetText("13.0")
	end
	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.telegraphframelayer
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		local timenumber
		if(self.alivetime<=8)then
			timenumber=string.format("%.0f",13.0-self.alivetime)
		else
			timenumber=string.format("%.1f",13.0-self.alivetime)
		end		
		if(self.alivetime>13)then
			timenumber=""
			self:Die()
		end
		self.drawable.frame.fontstring:SetText(timenumber)
	end
end

-- do
	-- local super=TRAININGGROUNDS_Drawable
	-- TRAININGGROUNDS_STORMWALLBLOCKADE_Drawable_StormsWailTimer=TRAININGGROUNDS_inheritsFrom(super)
	-- local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Sprite_StormsWailTimer
	
	-- function class:CreateFrame()
		-- --self.frames={}
		-- self.frame=TRAININGGROUNDS_ReusableFrames:GetFrame()
		-- --tinsert(self.frames,self.frame)
		-- -- self.timer=TRAININGGROUNDS_ReusableFrames:GetFrame()
		-- -- tinsert(self.frames,self.frame)
	-- end
	
	-- function class:SetFrameAppearance()
		-- self.frame:Show()
		-- self.frame:SetAlpha(1)
		-- self.width=50
		-- self.height=50
		-- self.frame:SetSize(50,50)
		-- self.frame.texture:Show()
		-- self.frame.texture:SetTexture("interface\\icons\\spell_nature_lightningoverload.blp")
		-- -- self.timer:Show()
		-- -- self.timer:SetParent(self.frame)
		-- -- self.timer:SetAllPoints(self.frame)
		-- -- self.timer.fontstring:Show()
		-- -- self.timer.fontstring:SetFont("Fonts\\FRIZQT__.TTF",48,"OUTLINE")
		-- -- self.timer.fontstring:SetText("99")
	-- end

	
-- end