do

	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	local REDX="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7:12\124t"
	local INTRO_TIME_MULTIPLIER=1.0

	TRAININGGROUNDS_STORMWALLBLOCKADE_VOLTAICFLASH_CustomDanceEventType={}
	local i=0
	i=i+1;TRAININGGROUNDS_STORMWALLBLOCKADE_VOLTAICFLASH_CustomDanceEventType.SUCCESS=i
	i=i+1;TRAININGGROUNDS_STORMWALLBLOCKADE_VOLTAICFLASH_CustomDanceEventType.HIT_BY_VOLTAICFLASH=i	

	
	local super=TRAININGGROUNDS_GroupDanceModule	
	TRAININGGROUNDS_STORMWALLBLOCKADE_GroupDanceModule_VoltaicFlash=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_GroupDanceModule_VoltaicFlash
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.successesinarow=0
		self.mode_choice=nil
		self.playerisdead=false
		self.lightninghits=0
	end


	
	function class:PopulateDefaultRaid(environment)	
		self.environment=environment

		self.katherine=self.bosscontroller.katherine	
		self.katherine.groupdancemodule=self
	

		self.raid:CreatePlayers(environment,0,0,0,1)
		self.raid:MakeAllPlayersIrrelevant()
		
		--TODO: move raid roles to another function
		self.tanks=self.raid.tanks
		self.rdps=self.raid.rdps
		self.player=self.raid.rdps[1]

							
		self:SetupInitialCameraFocus()
	end
	
	--TODO: maybe baseline, maybe not
	function class:SetupInitialCameraFocus()
		local camera=self.player.environment.cameramanager.camera
		tinsert(camera.focus,self.player)
	end

	
	function class:GetIntoInitialPosition()							
		self.katherine.x=yard*0
		self.katherine.y=yard*0
	
		
		self.player.x=yard*-6
		self.player.y=yard*-6
		--self.player.y=0--!!!
		self.player.currentfacing=math.pi*.35
		self.player.currentfacing_3D=self.player.currentfacing
		self.player.targetfacing_3D=self.player.currentfacing
		self.scenario.environment.game.environment_gameplay.cameramanager.camera.cangy=self.player.currentfacing

		-- --!!!
		-- self.floor.x=self.player.x
		-- self.floor.y=self.player.y
		-- self.scenario.TEMPfloor=self.floor
		self.scenario.player=self.player
		self.player.groupdancemodule=self
		



		
	end
	
	function class:StartDancing()
		-- TODO: for some reason we're not using this function when we really should be
	end
	
	function class:StartTestCycle()
		self:ResetPlayerDeathChecks()
		local totaltime=0

		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+0.25
		event.time=self.scenario.localtime+totaltime	
		event.execute=function() 
			self:ResetPlayerDeathChecks()			
		end
		tinsert(self.timedevents,event)	

		totaltime=totaltime+0.25		
		if(self.mode_choice==1)then
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 						
								for x=-2,1 do
									TRAININGGROUNDS_STORMWALLBLOCKADE_VoltaicFlashSetup((x*2+1)*yard*1.25,1,self.environment,false,self)
								end
							end;tinsert(self.timedevents,event)				
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=totaltime+3
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 						
								for x=-5,-3 do
									TRAININGGROUNDS_STORMWALLBLOCKADE_VoltaicFlashSetup((x*2+1)*yard*1.25,1,self.environment,true,self)
								end
								for x=2,4 do
									TRAININGGROUNDS_STORMWALLBLOCKADE_VoltaicFlashSetup((x*2+1)*yard*1.25,1,self.environment,true,self)
								end								
							end;tinsert(self.timedevents,event)				
		elseif(self.mode_choice==2)then
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 						
								for y=1,5 do
									TRAININGGROUNDS_STORMWALLBLOCKADE_VoltaicFlashSetup(-(y*2-1)*yard,2,self.environment,false,self)
								end
							end;tinsert(self.timedevents,event)				
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			totaltime=totaltime+3
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 						
								for y=1,5 do
									TRAININGGROUNDS_STORMWALLBLOCKADE_VoltaicFlashSetup((y*2-1)*yard,2,self.environment,true,self)
								end
							end;tinsert(self.timedevents,event)				
		elseif(self.mode_choice==3)then							
			for x=4,-5,-1 do
				local event=TRAININGGROUNDS_TimedDanceEvent.new()			
				event.time=self.scenario.localtime+totaltime
				event.execute=function() 					
									local reversezap=(x%2==0)
									TRAININGGROUNDS_STORMWALLBLOCKADE_VoltaicFlashSetup((x*2+1)*yard*1.25,1,self.environment,reversezap,self)
								end;tinsert(self.timedevents,event)			
				totaltime=totaltime+1.0
			end
		elseif(self.mode_choice==4)then							
			for y=-5,4 do
				local event=TRAININGGROUNDS_TimedDanceEvent.new()			
				event.time=self.scenario.localtime+totaltime
				event.execute=function() 						
									local reversezap=(y%2~=0)
									TRAININGGROUNDS_STORMWALLBLOCKADE_VoltaicFlashSetup((y*2+1)*yard,2,self.environment,reversezap,self)
								end;tinsert(self.timedevents,event)			
				totaltime=totaltime+1.0
			end
		elseif(self.mode_choice==5)then		
			for y=1,-2,-1 do	
				local event=TRAININGGROUNDS_TimedDanceEvent.new()
				event.time=self.scenario.localtime+totaltime
				event.execute=function() 			
								local reversezap=(y%2~=0)				
								for x=0,4 do
									TRAININGGROUNDS_STORMWALLBLOCKADE_VoltaicFlashSetup(yard*1.25*y*10+(x*2+1)*yard*1.25,1,self.environment,reversezap,self)
								end
							end;tinsert(self.timedevents,event)	
				if(y~=-2)then totaltime=totaltime+3.0 end
			end			
		elseif(self.mode_choice==6)then			
			for x=4,-5,-1 do
				local event=TRAININGGROUNDS_TimedDanceEvent.new()			
				event.time=self.scenario.localtime+totaltime
				event.execute=function() 					
									TRAININGGROUNDS_STORMWALLBLOCKADE_VoltaicFlashSetup((x*2+1)*yard*1.25,3,self.environment,false,self)
								end;tinsert(self.timedevents,event)								
			end
			totaltime=totaltime+0.5
		elseif(self.mode_choice==7)then			
			for x=4,-5,-1 do
				local event=TRAININGGROUNDS_TimedDanceEvent.new()			
				event.time=self.scenario.localtime+totaltime
				event.execute=function() 
									TRAININGGROUNDS_STORMWALLBLOCKADE_VoltaicFlashSetup((x*2+1)*yard*1.25,4,self.environment,true,self)
								end;tinsert(self.timedevents,event)								
			end
			totaltime=totaltime+0.5
		elseif(self.mode_choice==8)then							
			for x=9,-10,-1 do
				local event=TRAININGGROUNDS_TimedDanceEvent.new()			
				event.time=self.scenario.localtime+totaltime
				event.execute=function() 					
									local reversezap=(x%2==0)				
									TRAININGGROUNDS_STORMWALLBLOCKADE_VoltaicFlashSetup((x*2+1)*yard*1.25,1,self.environment,reversezap,self)
								end;tinsert(self.timedevents,event)			
				totaltime=totaltime+0.5
			end			
		end

			
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+3.0
		event.time=self.scenario.localtime+totaltime
		if(totaltime>0)then
			event.execute=function() 		
				local message
				if(self.lightninghits==0)then
					message="Dodged all lines!"
				elseif(self.lightninghits==1)then
					message="Hit by 1 line."
				else
					message="Hit by "..tostring(self.lightninghits).." lines.  Try again..."
				end
				TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,2.0,true)
			end
			tinsert(self.timedevents,event)
		end
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+2.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 		
				self.scenario:ShowButtons()
			end
			tinsert(self.timedevents,event)
		end	


	end
	
	
	
	function class:ResetPlayerDeathChecks()
		self.playerisdead=false
		self.lightninghits=0
	end
	

	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		--print(DECORFLOOR.x,DECORFLOOR.y,DECORFLOOR.z)
		--print(self.localtime)
		for i=#self.timedevents,1,-1 do
			local event=self.timedevents[i]
			if(self.localtime>=event.time)then	
				event.execute()
				tremove(self.timedevents,i)
			end
		end
	end
		
	function class:ReactToCustomDanceEvent(event)
		if(event.action==TRAININGGROUNDS_STORMWALLBLOCKADE_VOLTAICFLASH_CustomDanceEventType.HIT_BY_VOLTAICFLASH)then
			self.lightninghits=self.lightninghits+1
			self.player.combat:FlashDamageFlash_Alert()		
		end		
	end




	
	
	
	function class:GetEndOfCycleDelay()
		return 3.0
	end
	
	--TODO: cleanup (and cleanup on base groupdancemodule too?)
	function class:Cleanup()
		--TODO: NYI
	end
end
