local INTRO_TIME_MULTIPLIER=1.0
--local INTRO_TIME_MULTIPLIER=0.1

	

	
do
	TRAININGGROUNDS_TALOC_CustomDanceEventType={}
	local i=0
	i=i+1;TRAININGGROUNDS_TALOC_CustomDanceEventType.RAVENOUS_BLAZE_TARGETS=i
	i=i+1;TRAININGGROUNDS_TALOC_CustomDanceEventType.CHECK_FLARE_DISTANCE=i
	
	
	local super=TRAININGGROUNDS_GroupDanceModule	
	TRAININGGROUNDS_TALOC_GroupDanceModule_Taloc=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_TALOC_GroupDanceModule_Taloc
	
	
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		
		self.firsttechnique=true
		
		self.successesinarow=0
		
		self.combocounter=0
		self.foebreakercounter=0
		self.flamerendcounter=0
		self.searingtempestcounter=0	
		
		self.playeroddoreven_choice=nil
		self.playeroddoreven=nil
		self.soakedeven=false
		self.soakedodd=false
		self.playerdead=false		
	end

	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	local REDX="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7:12\124t"
	
	function class:PopulateDefaultRaid(environment)
		--TODO: this first line here assumes self.bosscontroller was set somewhere.
		-- move to separate function
		self.taloc=self.bosscontroller.taloc
		--print("PopulateDefaultRaid boss:",self.taloc)
		
		
		
		self.raid:CreatePlayers(environment,2,0,0,11)
		--self.raid:CreatePlayers(environment,2,0,0,2)
		self.raid:MakeAllPlayersIrrelevant()
		
		-- for now, no autocasts.
		for i=1,#self.raid.players do
			self.raid.players[i].combat.autocastmodule:Cleanup()
			self.raid.players[i].combat.autocastmodule=nil
		end
		-- self.taloc.combat.autocastmodule:Cleanup()
		-- self.taloc.combat.autocastmodue=nil		
	
		--TODO: move raid roles to another function
		self.tanks=self.raid.tanks
		self.currenttankindex=1
		self.rdps=self.raid.rdps
		self.player=self.raid.rdps[1]
		self.player.TEMP_TAG=true
		self.nonplayerrdps={}
		for i=2,11 do
		--for i=2,2 do
			tinsert(self.nonplayerrdps,self.rdps[i])
		end

		
		--TODO: set self.wmcontroller during setup
		self.wmcontroller=self.scenario.wmcontroller
		local wmcontroller=self.wmcontroller
							
		self:SetupInitialCameraFocus()
	
	end
	
	--TODO: maybe baseline, maybe not
	function class:SetupInitialCameraFocus()
		local camera=self.taloc.environment.cameramanager.camera
		
		tinsert(camera.focus,self.player)
		--tinsert(camera.focus,{x=0,y=AGGRAMAR_Y+yard*0})
		--tinsert(camera.focus,{x=0,y=AGGRAMAR_Y+yard*10})
		--tinsert(camera.focus,{x=0,y=AGGRAMAR_Y+yard*15})
		tinsert(camera.focus,self.taloc)	
	end


	
	function class:GetIntoInitialPosition()					
		self.taloc.x=0		
		self.taloc.y=0		

		--self:SetPlayerAIForInitialPositions()
		for i=1,#self.rdps do
			local raider=self.rdps[i]
			if(raider~=self.player)then
				local angle=((i-1)/(#self.rdps-1))*(math.pi)*0.5+(math.pi*.75)
				raider.x=yard*35*math.cos(angle)
				raider.y=0+yard*35*math.sin(angle)
				local targetx=yard*15*math.cos(angle)
				local targety=0+yard*15*math.sin(angle)
				local distx=targetx-raider.x
				local disty=targety-raider.y
				local distsqr=distx*distx+disty*disty
				raider.ai:SetTargetLocationAndPrecision({x=targetx,y=targety},yard*4)				
			end
		end		

		self.tanks[1].x=yard*30
		self.tanks[1].y=yard*0
		--self.maintanks[1].ai:SetTargetLocationAndPrecision({x=self.maintanks[1].x,y=yard*45},yard*2)
		self.tanks[1].ai:SetTargetLocationAndPrecision({x=yard*10,y=yard*0},yard*2)
		self.tanks[2].x=yard*30
		self.tanks[2].y=yard*7.7
		self.tanks[2].ai:SetTargetLocationAndPrecision({x=yard*7.7,y=yard*7.7},yard*2)
		
		-- for i=1,#self.raid.players do
			-- local raider=self.raid.players[i]
			-- if(raider~=self.player)then
				-- if(raider.ai.targetlocation)then
					-- raider.x=raider.ai.targetlocation.x
					-- raider.y=raider.ai.targetlocation.y-yard*30
				-- end
			-- end
		-- end
		
		self.player.x=0
		self.player.y=-15*yard
		self.player.currentfacing=math.pi/2
		

		
		-- local event=TRAININGGROUNDS_TimedDanceEvent.new()
		-- event.time=self.scenario.localtime+3.0*INTRO_TIME_MULTIPLIER;event.execute=function() 							
			-- TRAININGGROUNDS_FakeDBM_MinorWarning(DBM,"To move, use WASD, or press left+right mouse buttons together.")
						-- end;	tinsert(self.timedevents,event)			
		
		

		-- -- we used to call StartTestCycle here, but it's controlled by scenario's startbuttons now.
		-- local event=TRAININGGROUNDS_TimedDanceEvent.new()
		-- event.time=self.scenario.localtime+8.0*INTRO_TIME_MULTIPLIER;event.execute=function() 							
							-- self:StartTestCycle()
						-- end;		tinsert(self.timedevents,event)			
	end
	

	
	function class:StartDancing()
		-- TODO: for some reason we're not using this function when we really should be
	end
	
	function class:StartTestCycle()
		
		if(self.firsttechnique)then self:SoakChoiceMessage() end
		
		TRAININGGROUNDS_FakeDBM_MinorWarning(DBM,"Starting new Taeshalach Technique...")
		
		
		


		
		--!!!
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		event.time=self.scenario.localtime+5.0	--!!!
		event.execute=function() 
							self:ResetPlayerDeathChecks()
							--self:StartDancing()
							-- note: target is nil because tankswap() expects taloc to start with no target (or more importantly not target himself)
							TEMP_CastSpellOnTargetMobile(self.taloc,TRAININGGROUNDS_TALOC_Spell_TaeshalachTechnique,nil)
						end
		tinsert(self.timedevents,event)		
	end
	
	
	function class:ResetPlayerDeathChecks()
		self.playerdead=false
		self.taeshdead=false
		self.flaredead=false
		self.flaredotherplayers=false
		self.blazedead=false
		self.wakedead=false
		self.ringoutdead=false
		self.soakedeven=false
		self.soakedodd=false	
		

	end
	
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		
		--print(self.localtime)
		
		for i=#self.timedevents,1,-1 do
			local event=self.timedevents[i]
			if(self.localtime>=event.time)then	
				event.execute()
				tremove(self.timedevents,i)
			end
		end
		
		--TODO: super.step (step is not currently baseline)
		if(not self.ringoutdead)then
			if(self.player)then
				local distsqr=self.player.x*self.player.x+self.player.y*self.player.y
				local yard100sqr=(yard*50)*(yard*50)
				if(distsqr>yard100sqr)then
					self.ringoutdead=true
					self.playerdead=true
					self.player.combat:FlashDamageFlash_Alert()
					local text="RING OUT"
					TRAININGGROUNDS_FakeDBM_MajorWarning(DBM,text,3,true)
					print(REDX.." There are no invisible walls at the edge of the arena.  If you fall off, you're done.")
				end				
			end
		end		
	end
		
	function class:ReactToCombatEvent(event)
		--TODO: maybe this should be global (but we'd have to call it "TRAININGGROUNDS_yard" instead)
		local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)		
	
		local targetcombat=event.target
		local targetmobile=nil
		if(targetcombat)then targetmobile=targetcombat.owner end
		local camera=self.taloc.environment.cameramanager.camera
		
		if(event.action==TRAININGGROUNDS_CombatEventType.START_CASTING
		and event.subject==TRAININGGROUNDS_TALOC_Spell_TaeshalachTechnique)then		
			self.combocounter=0
			self.firsttechniquefoebreaker=false
			self.previoustechniquesearingtempest=false
		elseif(event.action==TRAININGGROUNDS_CombatEventType.START_CASTING
		and event.subject==TRAININGGROUNDS_TALOC_Spell_FoeBreaker)then	
			self.combocounter=self.combocounter+1
			self.foebreakercounter=self.foebreakercounter+1
			local foebreakercounterstring
			if(self.foebreakercounter%2==1)then
				foebreakercounterstring="1"
			else
				foebreakercounterstring="2"
			end
			if(self.combocounter==1)then self.firsttechniquefoebreaker=true end
			local text="Foe Breaker ("..foebreakercounterstring..")"
			TRAININGGROUNDS_FakeDBM_MinorWarning(DBM,text)
			
			
			self:TankSwap()
			self.maintank.ai:SetTargetLocationAndPrecision({x=0,y=self.taloc.y+yard*10},0)
			local offtankside=(self:GetTankIndex(self.offtank)-1)*2-1
			self.offtank.ai:SetTargetLocationAndPrecision({x=offtankside*yard*12.5,y=self.taloc.y},0)
			
			for i=1,#self.rdps do
				local raider=self.rdps[i]
				if(raider~=self.player)then
					local angle=((i-1)/(#self.rdps-1))*(math.pi/2)+(math.pi*5/4)
					local targetx=yard*10*math.cos(angle)
					local targety=AGGRAMAR_Y+yard*10*math.sin(angle)
					local distx=targetx-raider.x
					local disty=targety-raider.y
					local distsqr=distx*distx+disty*disty
					if(distsqr>(yard*4)*(yard*4))then
						raider.ai:SetTargetLocationAndPrecision({x=targetx,y=targety},yard*2)
					end
				end
			end
			
			self.previoustechniquesearingtempest=false
		elseif(event.action==TRAININGGROUNDS_CombatEventType.START_CASTING
		and event.subject==TRAININGGROUNDS_TALOC_Spell_FlameRend)then	
			self.combocounter=self.combocounter+1
			self.flamerendcounter=self.flamerendcounter+1
			if(self.combocounter==1)then self.firsttechniquefoebreaker=false end
			local flamerendcounterstring
			if(self.flamerendcounter%2==1)then 
				flamerendcounterstring=1
			else
				flamerendcounterstring=2
			end
			local text="Flame Rend ("..flamerendcounterstring..")"
			TRAININGGROUNDS_FakeDBM_MajorWarning(DBM,text,1)
			
			self:TankSwap()

			self.maintank.ai:SetTargetLocationAndPrecision({x=0,y=self.taloc.y-yard*10},0)
			local offtankside=(self:GetTankIndex(self.offtank)-1)*2-1
			self.offtank.ai:SetTargetLocationAndPrecision({x=offtankside*yard*10,y=self.taloc.y},0)
			
			local soaklist,offlist
			if(self.flamerendcounter%2==0)then 
				soaklist=self.evens;offlist=self.odds
			else 
				soaklist=self.odds;offlist=self.evens
			end
			
			for i=1,#soaklist do
				soaklist[i].ai:SetTargetLocationAndPrecision({x=0,y=AGGRAMAR_Y-yard*20},yard*2.5)				
			end
			--TODO: depending on situation, move out to dodge searingtempest
			for i=1,#offlist do
				local off=offlist[i]
				local offside=TRAININGGROUNDS_signum(off.x)
				if(offside==0)then offside=-1 end
				off.ai:SetTargetLocationAndPrecision({x=offside*yard*15,y=AGGRAMAR_Y},yard*2.5)				
			end
			
			self.previoustechniquesearingtempest=false
		elseif(event.action==TRAININGGROUNDS_CombatEventType.START_CASTING
		and event.subject==TRAININGGROUNDS_TALOC_Spell_SearingTempest)then	
			self.combocounter=self.combocounter+1
			self.searingtempestcounter=self.searingtempestcounter+1
			
			--TODO: check for SearingTempestIntro instead of SearingTempest?
			local text="Searing Tempest - run away"
			TRAININGGROUNDS_FakeDBM_MajorWarning(DBM,text,4)
			
			tinsert(camera.focus,{x=0,y=AGGRAMAR_Y-yard*50})
			tinsert(camera.focus,{x=0,y=AGGRAMAR_Y+yard*20})
			
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			event.time=self.scenario.localtime+1.5;event.execute=function() 
								self:StampedingRoar(self.maintanks[1])
							end;tinsert(self.timedevents,event)	

			
			--print("Debug: first Searing Tempest Dance")
			self:SearingTempestDance()
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			event.time=self.scenario.localtime+2;event.execute=function() 
								self:SearingTempestDance()
							end;tinsert(self.timedevents,event)				
			event.time=self.scenario.localtime+4;event.execute=function() 
								self:SearingTempestDance()
							end;tinsert(self.timedevents,event)	
			local event=TRAININGGROUNDS_TimedDanceEvent.new()
			event.time=self.scenario.localtime+5;event.execute=function() 
								self:SearingTempestDance()
							end;tinsert(self.timedevents,event)	
			
			self.previoustechniquesearingtempest=true
		elseif(event.action==TRAININGGROUNDS_CombatEventType.COMPLETE_CASTING
		and event.subject==TRAININGGROUNDS_TALOC_Spell_SearingTempest)then				
			--TODO: STOP_CASTING instead of COMPLETE_CASTING
			--TODO: WARNING: making a big assumption here that the searingtempest focus is the last one(s)
			--print("Remove camera focus",#camera.focus)
			tremove(camera.focus,#camera.focus)
			tremove(camera.focus,#camera.focus)
			--players won't make it this far before agg casts next ability, but it's better than standing still
			for i=1,#self.raid.players do
				if(self.raid.players[i]~=self.player)then
					self.raid.players[i].ai:SetTargetLocationAndPrecision({x=0,y=AGGRAMAR_Y},0)					
				end
			end
			
		elseif(event.action==TRAININGGROUNDS_CombatEventType.COMPLETE_CASTING
		and event.subject==TRAININGGROUNDS_TALOC_Spell_FlameRend)then	
			local event=TRAININGGROUNDS_TimedDanceEvent.new();event.time=self.scenario.localtime+0.4;event.execute=function() 
				--print("Flamerendcounter",self.flamerendcounter,"oddoreven",self.playeroddoreven)
				--print("Debug: oddoreven",self.playeroddoreven)
				if(self.flamerendcounter%2==1)then
					if(self.soakedodd==false and self.playeroddoreven==1)then
						local text="You didn't soak your assigned Flame Rend!"
						TRAININGGROUNDS_FakeDBM_MajorWarning(DBM,text,3,true)
						print(REDX.." If Flame Rend doesn't hit enough players, Taloc gains a permanent enrage buff.  Pay attention to your assignment at the start of each Taeshalach Technique.")
						self.playerdead=true
						self.taeshdead=true
					end
				end
				if(self.flamerendcounter%2==0)then
					if(self.soakedeven==false and self.playeroddoreven==2)then
						--print("Debug: soaked even FALSE (about to show message)")
						local text="You didn't soak your assigned Flame Rend!"
						TRAININGGROUNDS_FakeDBM_MajorWarning(DBM,text,3,true)						
						print(REDX.." If Flame Rend doesn't hit enough players, Taloc gains a permanent enrage buff.  Pay attention to your assignment at the start of each Taeshalach Technique.")
						self.playerdead=true	
						self.taeshdead=true
					end
				end
			end;tinsert(self.timedevents,event)			
		elseif(event.action==TRAININGGROUNDS_CombatEventType.AURA_APPLIED
		and event.subject==TRAININGGROUNDS_TALOC_Aura_SearingBinding)then
			--print("Event.target:",event.target)
			self:MoveRaidersAwayFromTargetMobile(event.target.owner,yard*22.5)
		elseif(event.action==TRAININGGROUNDS_CombatEventType.HIT_BY_ATTACK
		and event.subject==TRAININGGROUNDS_TALOC_Spell_FoeBreaker)then		
			--TODO: rename event.target to event.targetcombat?
			if(targetcombat==self.player.combat)then				
				self.player.combat:FlashDamageFlash_Alert()
				self.playerdead=true
				self.taeshdead=true
				local text="You were hit by Foe Breaker!"
				TRAININGGROUNDS_FakeDBM_MajorWarning(DBM,text,3,true)
				print(REDX.." Foe Breaker deals 43,000,000 damage to every player it hits.  Don't stand in it.")
				--TODO: also, player dies
			end
		elseif(event.action==TRAININGGROUNDS_CombatEventType.HIT_BY_ATTACK
		and event.subject==TRAININGGROUNDS_TALOC_Spell_FlameRend)then	
			--TODO: rename event.target to event.targetcombat?
			if(targetcombat==self.player.combat)then				
				self.player.combat:FlashDamageFlash_Alert()
				if(self.flamerendcounter%2==1)then
					self.soakedodd=true
				else
					--print("Debug: soaked even TRUE")
					self.soakedeven=true
				end
				
				if(self.soakedodd and self.soakedeven)then
					self.playerdead=true
					self.taeshdead=true
					local text="You soaked double Flame Rends!"
					TRAININGGROUNDS_FakeDBM_MajorWarning(DBM,text,3,true)
					print(REDX.." Soak one (and only one) Empowered Flame Rend per Taeshalach Technique.  If you soak both, the second one will hit you for 6x damage.")
				end
				
				--print("You were hit by Flame Rend!")
				--TODO: also, player dies
			elseif(targetcombat==self.taloc.combat)then
				-- skip Taloc
					--TODO: skip taloc during the initial target search
			else
				--TODO NEXT: don't run back here unless you're tank, you already soaked
				--print("Debug: foolishly set Flame Rend runback")
				targetmobile.ai:SetTargetLocationAndPrecision({x=targetmobile.x,y=targetmobile.y},yard*2.5)	
			end
		elseif(event.action==TRAININGGROUNDS_CombatEventType.HIT_BY_ATTACK
		and event.subject==TRAININGGROUNDS_TALOC_Spell_SearingTempest)then	
			if(targetcombat==self.player.combat)then
				self.player.combat:FlashDamageFlash_Alert()
				self.playerdead=true
				self.taeshdead=true
				local text="You were hit by Searing Tempest!"
				TRAININGGROUNDS_FakeDBM_MajorWarning(DBM,text,3,true)
				print(REDX.." Empowered Searing Tempest pulls you in.  Take advantage of the tank's Stampeding Roar and avoid 50,000,000 Fire damage.")
			end
		elseif(event.action==TRAININGGROUNDS_CombatEventType.HIT_BY_ATTACK
		and event.subject==TRAININGGROUNDS_TALOC_Aura_SearingBinding)then
			--TODO: rename event.target to event.targetcombat?
			if(targetcombat==self.player.combat)then				
				self.player.combat:FlashDamageFlash_Alert()
				self.playerdead=true
				self.taeshdead=true
				local text="You were hit by Searing Binding!"
				TRAININGGROUNDS_FakeDBM_MajorWarning(DBM,text,3,true)
				print(REDX.." Stay 20 yards away from the Empowered Foe Breaker tank to avoid Searing Binding.")
				--TODO: also, player dies
			end				
		end
		-- not "elseif"; we already checked once for flamerend; this is a new independent check that occurs regardless
		if(event.action==TRAININGGROUNDS_CombatEventType.COMPLETE_CASTING
		and event.subject==TRAININGGROUNDS_TALOC_Spell_FlameRend)then				
			if(self.combocounter==5)then
				local event=TRAININGGROUNDS_TimedDanceEvent.new();event.time=self.scenario.localtime+self:GetEndOfCycleDelay();event.execute=function() 
					self:ShowResults()
				end;tinsert(self.timedevents,event)	
			end
		end
	end
	
	

	--TODO: this should probably be baseline, somehow
	function class:TankSwap()
		if(not(self.firsttechniquefoebreaker and self.previoustechniquesearingtempest))then	
			if(not self.taloc.combat.targetcombat)then
				self.maintank=self.maintanks[1]
				self.offtank=self.maintanks[2]
			else
				local temp=self.maintank
				self.maintank=self.offtank
				self.offtank=temp
			end
			--print("maintank is now",self.maintank)
			TEMP_CastSpellOnTargetMobile(self.maintank,TRAININGGROUNDS_Spell_SampleTaunt,self.taloc)
			
		else
			--print("Debug: no swap exception")
		end
	end
	
	
	
	function class:GetTankIndex(tank)
		if(self.maintanks[1]==tank)then return 1 end
		if(self.maintanks[2]==tank)then return 2 end
	end
	
	
	--TODO: spell
	function class:StampedingRoar(castermobile)		
		local raiders=self.player.environment.raiders
		for i=1,#raiders do
			local mob=raiders[i]
			local xdist=mob.x-castermobile.x
			local ydist=mob.y-castermobile.y
			local distsqr=xdist*xdist+ydist*ydist
			local yard45=yard*45
			if(distsqr<=yard45*yard45)then
				--TODO: maybe rearrange ApplyAuraByClass, we get target and caster mixed up a lot
				mob.combat:ApplyAuraByClass(TRAININGGROUNDS_Aura_StampedingRoar,castermobile.combat)
				if(mob==self.player)then
					TRAININGGROUNDS_FakeDBM_MinorWarning(DBM,"(Stampeding Roar)")
				end
			end
		end
	end
	
	function class:ShowResults()
		-- need to stall long enough that even soak can be evaluated
		local event=TRAININGGROUNDS_TimedDanceEvent.new();event.time=self.scenario.localtime+0.6;event.execute=function() 
			if(self.playerdead==false)then				
				TRAININGGROUNDS_FakeDBM_MajorWarning(DBM,"Good!",1,true)								
				self.successesinarow=self.successesinarow+1
			else				
				TRAININGGROUNDS_FakeDBM_MajorWarning(DBM,"Try again...",3,true)								
				self.successesinarow=0
			end
			if(self.successesinarow>=2)then
				local event2=TRAININGGROUNDS_TimedDanceEvent.new();event2.time=self.scenario.localtime+1;event2.execute=function() 
					TRAININGGROUNDS_FakeDBM_MinorWarning(DBM,"("..tostring(self.successesinarow).." successes in a row!)")
				end;tinsert(self.timedevents,event2)
			end				
		end;tinsert(self.timedevents,event)
		
		local event3=TRAININGGROUNDS_TimedDanceEvent.new();event3.time=self.scenario.localtime+self:GetEndOfCycleDelay();event3.execute=function() 
			self:StartTestCycle()
		end;tinsert(self.timedevents,event3)			

	end
	
	function class:MoveRaidersAwayFromTargetMobile(targetmobile,targetdistance)
		for i=1,#self.raid.players do
			local raider=self.raid.players[i]
			--print("Raiderx:",raider.x,"Targetx:",targetmobile.x)
			if(raider~=self.player)then
				if(raider~=targetmobile)then
					local raiderx=raider.x
					local raidery=raider.y
					
					local distx=raiderx-targetmobile.x
					local disty=raidery-targetmobile.y
					local distsqr=distx*distx+disty*disty
					
					local distx,disty,distsqr
					
					if(raider.ai.targetlocation)then
						distx=raider.ai.targetlocation.x-targetmobile.x
						disty=raider.ai.targetlocation.y-targetmobile.y
						distsqr=distx*distx+disty*disty				
					else
						distx=raider.x-targetmobile.x
						disty=raider.y-targetmobile.y
						distsqr=distx*distx+disty*disty				
					end
					
					if(distsqr<targetdistance*targetdistance)then						
						-- local dist=math.sqrt(distsqr)						
						-- local uvx=distx/dist
						-- local uvy=disty/dist
						-- local newx=targetmobile.x+uvx*targetdistance
						-- local newy=targetmobile.y+uvy*targetdistance						
						local angle=math.atan2(disty,distx)	
						local newx=targetmobile.x+targetdistance*math.cos(angle)
						local newy=targetmobile.y+targetdistance*math.sin(angle)
						
						local platformdistsqr=(newx*newx+newy*newy)
						if(platformdistsqr>(45*yard*45*yard))then
							--print("Angle:",angle)
							if(angle>0)then
								angle=-angle
							end
							do
								if(angle>-math.pi/8)then
									-- print("Correcting for edge of platform")
									-- print("Platformdist:",math.sqrt(platformdistsqr))
									-- print("old angle:",angle)
									angle=angle-(math.pi/8+math.random()*math.pi/4)
									-- print("new angle:",angle)
								end
								if(angle<-math.pi*7/8)then
									angle=angle+(math.pi/8+math.random()*math.pi/4)
								end
							end
							newx=targetmobile.x+targetdistance*math.cos(angle)
							newy=targetmobile.y+targetdistance*math.sin(angle)
							local platformdistsqr=(newx*newx+newy*newy)							
							--print("New platformdist:",math.sqrt(platformdistsqr))
						end
						raider.ai:SetTargetLocationAndPrecision({x=newx,y=newy},0)

					end
				end
			end
		end
	end
	
	function class:SearingTempestDance()
		self:MoveRaidersAwayFromTargetMobile(self.taloc,yard*45)
		local downtank,sidetank
		if(self.combocounter==2)then
			downtank=self.maintank;sidetank=self.offtank
		else
			downtank=self.offtank;sidetank=self.maintank
		end
		downtank.ai:SetTargetLocationAndPrecision({x=0,y=self.taloc.y-yard*40},0)
		local sidetankside=(self:GetTankIndex(sidetank)-1)*2-1		
		sidetank.ai:SetTargetLocationAndPrecision({x=40*yard*sidetankside,y=self.taloc.y-yard*10},0)
	end

	function class:SoakChoiceMessage()
		if(whichchoice==3)then 
			print("You have chosen to soak RANDOM Flame Rends!")
			return 
		end
		local soaktext
		if(self.playeroddoreven_choice==1)then
			soaktext="You have chosen to soak ODD Flame Rends."
		elseif(self.playeroddoreven_choice==2)then
			soaktext="You have chosen to soak EVEN Flame Rends."
		elseif(self.playeroddoreven_choice==3)then
			soaktext="You have chosen to soak RANDOM Flame Rends!"
		end		
		TRAININGGROUNDS_FakeDBM_MajorWarning(DBM,soaktext,1)
		if(DBM) then print(soaktext) end			
	end
	
	
	function class:GetEndOfCycleDelay()
		return 3.0
	end
	
	--TODO: cleanup (and cleanup on base groupdancemodule too?)
	
	
	
	function class:Cleanup()
		--TODO: NYI
	end
end
