

do
	local super=TRAININGGROUNDS_Scenario
	TRAININGGROUNDS_UUNAT_Scenario_Uunat = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_UUNAT_Scenario_Uunat

	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)	
	
	function class:Populate()
		super.Populate(self)				
			
		self:CreateBossController()
		
		local currentplayer=self.raid.rdps[1]
		self.controls:SetPlayer(currentplayer)
		currentplayer:SetPlayerAppearance()
		self.player=currentplayer
		local relevant=TRAININGGROUNDS_Aura_PlayerControlled.new()
		relevant:Setup(currentplayer.combat,currentplayer.combat,currentplayer:GetLocalTime())			

		self.uunat.groupdancemodule:GetIntoInitialPosition()
		
		--local YDIFF=100
		--local XDIFF=225
		local XDIFF=0
		local YDIFF=0
		
		self.startbuttons={}
	
		local startbutton	
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2-XDIFF
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-200+YDIFF
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Piercing Gaze")
		startbutton.drawable.frame:SetScript("OnClick",function()					
					self.uunat.groupdancemodule.mode_choice=1			
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)		
		-- local startbutton	
		-- startbutton=TRAININGGROUNDS_Button.new()
		-- startbutton:Setup(self.environment.game.environment_hud)
		-- startbutton.x=self.environment.game.window.frame:GetWidth()/2-0
		-- startbutton.y=self.environment.game.window.frame:GetHeight()/2-200+YDIFF
		-- startbutton.drawable.width=200;startbutton.drawable.height=140				
		-- startbutton:SetText("Void Crash")
		-- startbutton.drawable.frame:SetScript("OnClick",function()					
					-- self.uunat.groupdancemodule.mode_choice=2
					-- self:OnStartButton()
				-- end)
		-- tinsert(self.startbuttons,startbutton)			
		-- local startbutton	
		-- startbutton=TRAININGGROUNDS_Button.new()
		-- startbutton:Setup(self.environment.game.environment_hud)
		-- startbutton.x=self.environment.game.window.frame:GetWidth()/2+XDIFF
		-- startbutton.y=self.environment.game.window.frame:GetHeight()/2-200-YDIFF
		-- startbutton.drawable.width=200;startbutton.drawable.height=140				
		-- startbutton:SetText("Soak Oblivion Tear\r(and reset the floor)")
		-- startbutton.drawable.frame:SetScript("OnClick",function()
					-- self.uunat.groupdancemodule.mode_choice=3
					-- self:OnStartButton()
				-- end)
		-- tinsert(self.startbuttons,startbutton)		

	

	end

	function class:SetCamera()
		self.environment.game.environment_gameplay.cameramanager.camera=TRAININGGROUNDS_Camera3D.new()
		self.environment.game.environment_gameplay.cameramanager.camera:Setup(self.environment.game.environment_gameplay)
	end	

	--TODO: somehow connect camera+playercontrols, since they're usually codependent
	function class:CreatePlayerControls()
		local controls = TRAININGGROUNDS_ScenarioPlayerControls_CharacterMode_3D.new()
		controls:Setup(self.environment,self)			
		self.controls=controls
	end
	
	function class:CreateBossController()
		self.uunat=TRAININGGROUNDS_UUNAT_BossController_Uunat.new()
		--TODO: at this point it becomes very awkward that scenario.environment is not scenario.environment_gameplay
		self.uunat:Setup(self.environment.game.environment_gameplay,self)
		self.uunat:CreateBoss()		
		self.uunat.groupdancemodule.bosscontroller=self.uunat
		self.uunat.groupdancemodule:PopulateDefaultRaid(self.environment.game.environment_gameplay)
	end
	
	function class:OnStartButton()
		for i=1,#self.startbuttons do
			self.startbuttons[i].visible=false	
			self.startbuttons[i].drawable.frame:EnableMouse(false)
		end
		self.uunat.groupdancemodule:StartTestCycle()
	end
	
	function class:ShowButtons()
		for i=1,#self.startbuttons do
			self.startbuttons[i].visible=true	
			self.startbuttons[i].drawable.frame:EnableMouse(true)
		end	
	end

	function class:OnEscapeKey()
		self.environment.game:LoadScenarioByClass(TRAININGGROUNDS_Scenario_Menu)
	end
	
	function class:PostMove(elapsed)
		super.PostMove(elapsed)
		--print("PostMove",self.player)
		if(self.player)then
			local dist=math.sqrt(self.player.x*self.player.x+self.player.y*self.player.y)
			local MAX_DIST=yard*50*.6
			if(dist>MAX_DIST)then
				local unitvectorx=self.player.x/dist
				local unitvectory=self.player.y/dist
				self.player.x=unitvectorx*MAX_DIST
				self.player.y=unitvectory*MAX_DIST
			end
		end
	end
	
end
