do

	--TODO: offhand

	TRAININGGROUNDS_AutoCastModule = {}
	local class=TRAININGGROUNDS_AutoCastModule
	class.__index = class
	function class.new()
		local self=setmetatable({}, class)	
		return self
	end

	--TODO: create-autocastmodule-from-weapon class
	
	function class:Setup(ownercombat)
		self.ownercombat=ownercombat
		self:SetCustomInfo()
	end
	
	function class:SetCustomInfo()
		self.swingtimer=1.5		
		--self.swingtimer=15 --!!!
		self.spell=TRAININGGROUNDS_Spell_SampleDistractingMeleeAttack.new()
		self.spell:Setup(self.ownercombat)
--		print("Self.spell is now",self.spell)
	end
	
	--TODO: animation function
	
	function class:StartAttacking()
		if(not self.attacking)then
			--TODO: don't add swingtimer; first autocast occurs immediately.
			-- however, this only applies if nextswingtime>localtime+swingtimer, or something like that?
				-- (to prevent spam cancelling and restarting autocast)
			self.nextswingtime=self.ownercombat.localtime+self.swingtimer
			self.attacking=true
			--print(self.ownercombat,"starts attacking",self.nextswingtime,self.ownercombat.localtime)
		end
	end
	
	function class:StopAttacking()
		self.attacking=false
	end
	
	
	function class:Step(elapsed)
		----TODO LATER: this is autoattack code, not autocast code
	
		--if(self.attacking)then
		-- -- if we are targeting someting:
			-- local localtime=self.ownercombat.localtime
			-- if(localtime>=self.nextswingtime)then
				-- --print("Attempt autocast")
				-- --print(self.ownercombat,"combat.AutoCastModule swing")
				-- --TryQueue spell			
				-- --TODO: make it more obvious that spell.targetcombat must be manually set,
					-- -- or go the other route and require passing targetcombat during NewQueue
				-- local autospell=self.spell:NewQueue()				
				-- --autospell.targetcombat=self.ownercombat.targetcombat	-- DEPRECATED, REMOVE
				-- local errorcode=self.ownercombat:TryQueue(autospell)
				-- if(errorcode==nil)then
					-- local spellinstance=autospell:NewCast()
					-- --spellinstance.castercombat=self.ownercombat
					-- spellinstance.targetcombat=autospell.targetcombat
					-- spellinstance:CompleteCasting(self.nextswingtime)
					-- --print("Autoattack")
				-- else
					-- --TODO: this currently produces a "can't autocast while casting" message; comment this out later
					-- --print("errorcode:",errorcode)
					-- --TODO: check in-game whether some autocast errors should produce an error message
				-- end
				-- --regardless of whether the spell was successful:
					-- -- (unsuccessful spell expected to be caused by out-of-range)
				-- self.nextswingtime=self.nextswingtime+self.swingtimer
			-- else
				-- -- if(self.ownercombat.owner:Class()==TRAININGGROUNDS_VARIMATHRAS_Mobile_Varimathras)then
					-- -- print("varimathras localtime/swingtime",localtime,self.nextswingtime)
				-- -- end
			-- end
		-- -- end
		-- else
			-- -- if(self.ownercombat.owner:Class()==TRAININGGROUNDS_VARIMATHRAS_Mobile_Varimathras)then
				-- -- print("varimathras autocast is off...")
			-- -- end
		-- end
	end
	
	function class:Cleanup()
		--TODO: cleanup
	end
	
end


do

	local super=TRAININGGROUNDS_AutoCastModule
	TRAININGGROUNDS_AutoCastModule_Ranged=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_AutoCastModule_Ranged
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.spell=TRAININGGROUNDS_Spell_SampleDistractingRangedAttack.new()
		self.spell:Setup(self.ownercombat)
	end
	
	function class:Cleanup()
		--TODO: cleanup
	end
	
end