

TRAININGGROUNDS_CombatModule_SampleClass=TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_CombatModule)
TRAININGGROUNDS_CombatModule_SampleClass_RDPS=TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_CombatModule_SampleClass)

function TRAININGGROUNDS_CombatModule_SampleClass:Setup(environment)
	TRAININGGROUNDS_CombatModule.Setup(self,environment)
	--TODO: non-playercharacters do not necessarily need a damageflash
	--TODO: objects that don't call super during CreateCombatModule (i.e. all of them) won't inherit damageflash
		-- so we'll need to move to a CreateDamageFlash function
		
	--TODO: self.damageflash is treated as a hardcoded special case and should be moved to a SetupDamageFlash function
	self.damageflash=TRAININGGROUNDS_Aura_Visual_ModelLighting_DamageFlash.new()
	self.damageflash:Setup(self,self,self.localtime)
end


function TRAININGGROUNDS_CombatModule_SampleClass_RDPS:CreateRaidRole()
	self.raidrole=TRAININGGROUNDS_RaidRole_RDPS.new()
	self.raidrole:Setup(self)
end

function TRAININGGROUNDS_CombatModule_SampleClass_RDPS:CreateSpells()
	self.roll=TRAININGGROUNDS_Spell_Roll.new()
	self.roll:Setup(self,nil)
	--print("RDPS self.roll:",self.roll)
end

function TRAININGGROUNDS_CombatModule_SampleClass_RDPS:CreateAutoCast()
	self.autocastmodule=TRAININGGROUNDS_AutoCastModule_Ranged.new()
	self.autocastmodule:Setup(self)
end


--------------------------------
--------------------------------
--------------------------------
--------------------------------
--------------------------------

TRAININGGROUNDS_CombatModule_SampleClass_MDPS=TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_CombatModule_SampleClass)
function TRAININGGROUNDS_CombatModule_SampleClass_MDPS:CreateRaidRole()
	self.raidrole=TRAININGGROUNDS_RaidRole_MDPS.new()
	self.raidrole:Setup(self)
end
function TRAININGGROUNDS_CombatModule_SampleClass_MDPS:CreateAutoSpell()
	self.autospell=TRAININGGROUNDS_Spell_SampleMeleeAttack.new()
	self.autospell:Setup(self,nil)
	tinsert(self.spellbook,self.autospell:Class())	
	--print("Melee's autospell is now",self.autospell,"and ownercombat is",self)
end
TRAININGGROUNDS_CombatModule_SampleClass_RHealer=TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_CombatModule_SampleClass)
function TRAININGGROUNDS_CombatModule_SampleClass_RHealer:CreateRaidRole()
	self.raidrole=TRAININGGROUNDS_RaidRole_RHealer.new()
	self.raidrole:Setup(self)
end
function TRAININGGROUNDS_CombatModule_SampleClass_RHealer:CreateAutoCast()
	self.autocastmodule=TRAININGGROUNDS_AutoCastModule_Ranged.new()
	self.autocastmodule:Setup(self)
end


TRAININGGROUNDS_CombatModule_SampleClass_MHealer=TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_CombatModule_SampleClass)
TRAININGGROUNDS_CombatModule_SampleClass_MTank=TRAININGGROUNDS_inheritsFrom(TRAININGGROUNDS_CombatModule_SampleClass)

-- RESOLVED: reason why heals+tanks weren't taking damage was because they weren't given a sampleclass combatmodule
