local super=TRAININGGROUNDS_Spell
TRAININGGROUNDS_Spell_SampleDistractingMeleeAttack = TRAININGGROUNDS_inheritsFrom(super)
local class=TRAININGGROUNDS_Spell_SampleDistractingMeleeAttack

function class:SetCustomInfo()
	super.SetCustomInfo(self)
	self.projectileclass=TRAININGGROUNDS_Projectile_SampleMeleeAttack
	
	self.basecastduration=0
	--self.range=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(5.0)
	
	-- Melee range is currently 2 yards.  See Mobile:SetCustomInfo for explanation.
		--TODO: explanation will eventually move to wherever we set player hitboxes
	self.range=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(2.0)
	self.melee=true
	self.basegcd=1.000
	self.respectsgcd=true
end

function class:StartCasting(caststarttime)
	super.StartCasting(self,caststarttime)
	self:ApplyGCD(caststarttime)
end

function class:BeginCastingAnimationFunction()
	-- do nothing (and don't call super)
	--print("Melee:BeginCastingAnimationFunction")
end

function class:CompleteCastingAnimationFunction()	
	local i=math.floor(math.random()*3)+1
	
	if(i==1)then
		self.castercombat.owner.drawable:TryAttack2H()
	elseif(i==2)then
		self.castercombat.owner.drawable:TryAttack2HL()
	elseif(i==3)then
		self.castercombat.owner.drawable:TryAttackUnarmed()
	end
end

