do
	--TODO: some things might still be broken here.
	-- this is one of our first multi-frame drawables
		-- and we've rather sloppily copied just barely enough functions to make it work where we first tested it.
	
	local super=TRAININGGROUNDS_Drawable_Sprite
	TRAININGGROUNDS_Drawable_Sprite_MovementArrow=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_Drawable_Sprite_MovementArrow
	
	function class:CreateFrame()		
		self.line1=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.line2=TRAININGGROUNDS_ReusableFrames:GetFrame()
		--TODO: if we can rename "self.frame" to "self.point", do so	
		self.frame=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.frames={}
		tinsert(self.frames,self.line1)
		tinsert(self.frames,self.line2)
		tinsert(self.frames,self.frame)
	end
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.visible=true
	end
	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.movementarrowframelayer		
	end
	
	function class:SetFrameLevel()
		for i=1,#self.frames do
			self.frames[i]:SetFrameLevel(self.framelayer.level)
		end
	end	
	
	function class:ShowFrames()	
		for i=1,#self.frames do
			self.frames[i]:SetAlpha(self.alpha)
		end
	end

	function class:HideFrames()	
		for i=1,#self.frames do
			self.frames[i]:SetAlpha(0)
		end
	end
	
	function class:SetFrameAppearance()
		--texture will be setup during TAXIFRAME_TextureAdd
		self.width=100
		self.height=100
		--TODO: width/heigth should go here, but should we move SetParent+SetPoint somewhere else?
		for i=1,#self.frames do
			self.frames[i]:SetParent(self.parentframe)
			self.frames[i]:SetPoint("TOPLEFT",self.parentframe,"CENTER",0,0)
			self.frames[i]:Show()
			self.frames[i]:SetWidth(self.width)
			self.frames[i]:SetHeight(self.height)		
		end
	end
	
	--TODO: some arrows need to update position (and/or flash) every frame
		-- "radius" refers to half the length of the side of the arrow pointer triangle
	function class:SetArrow(x1,y1,x2,y2,width,radius)
		--WARNING: workaround for radius being half of expected
			-- TODO: fix math so we don't have to multiply by 2
			radius=radius*2
		local angle=math.atan2(y2-y1,x2-x1)
		local angle90=angle+math.pi/2
		local root3=math.sqrt(3)
		-- we didn't know what to name these vars.  "corner-1 x", "line-1 x", etc
		local l1x=x1 	-- "L-ONE"
		local l1y=y1	
		local l2x=x2-math.cos(angle)*radius*root3
		local l2y=y2-math.sin(angle)*radius*root3
		--TODO LATER: reduce trig calls	
		local c1x=l1x-math.cos(angle90)*width
		local c1y=l1y-math.sin(angle90)*width
		local c2x=l1x+math.cos(angle90)*width
		local c2y=l1y+math.sin(angle90)*width
		-- c3 is diagonally opposite c1
		local c3x=l2x+math.cos(angle90)*width
		local c3y=l2y+math.sin(angle90)*width
		local c4x=l2x-math.cos(angle90)*width
		local c4y=l2y-math.sin(angle90)*width
		
		self:SetFrameVertices(self.line1,c1x,c1y,c2x,c2y,c4x,c4y)
		self:SetFrameVertices(self.line2,c3x,c3y,c4x,c4y,c2x,c2y)
		self:SetFrameVertices(self.frame,x2,y2,l2x+math.cos(angle90)*radius,l2y+math.sin(angle90)*radius,l2x-math.cos(angle90)*radius,l2y-math.sin(angle90)*radius)
		
		--self:SetFrameVertices(self.frame,0,0,100,0,0,100)
		--self:SetFrameVertices(self.frame,100,0,100,0,0,100)
		--self:SetFrameVertices(self.frame,-300,-30,-300,0,13,-30)
		
	end
	
	function class:SetFrameVertices(frame,x1,y1,x2,y2,x3,y3)
		--print("D_P:SetVertices")
		--print("Parentframe size: ",self.parentframe:GetSize())
		frame.x1=x1
		frame.y1=y1
		frame.x2=x2
		frame.y2=y2
		frame.x3=x3
		frame.y3=y3
		--TAXIFRAME_TextureAdd(self.frame,nil,nil,nil,nil,x1,y1,x2,y2,x3,y3)
		--self.frame:SetSize(self.parentframe:GetWidth()*3,self.parentframe:GetHeight()*3)
		--print("Poly size:",self.frame:GetWidth(),self.frame:GetHeight())
		--self.frame.texture:SetSize(self.frame:GetWidth(),self.frame:GetHeight())
		--TODO: divide by frame.width instead of hardcoding 100?

		--TODO: drawable_polygon:GetYStretchMultiplier()
		local ystretch=self.owner.environment.cameramanager.camera.ystretch
		--TAXIFRAME_TextureAdd(self.frame,nil,nil,nil,nil,x1,y1,x2,y2,x3,y3)
		TAXIFRAME_TextureAdd(frame,100,1,1,1,x1*0.01,-y1*0.01*ystretch,x2*0.01,-y2*0.01*ystretch,x3*0.01,-y3*0.01*ystretch)		
		--print("called TextureAdd",x1,y1,x2,y2,x3,y3,"  frame:GetSize:",frame:GetSize())
	end
	
	--TODO: Drawable:SetColor (can call drawable_model:setlighting)
	function class:SetColor(R,G,B,A)
		for i=1,#self.frames do
			self.frames[i].texture:SetGradientAlpha("HORIZONTAL",R,G,B,A,R,G,B,A)
		end
	end
	
	-- --TODO:
	function class:ArrangeFrame(parentanchor,x,y,wid,hgt,yaw,pitch)		
		for i=1,#self.frames do
			self.frames[i]:SetParent(self.parentframe)
		end
		
	end	
	function class:SetFrameSizeAndOrientation(wid,hgt,yaw,pitch)
		--TODO: (?)
		--do nothing, maybe		
	end	
	
	function class:Cleanup()
		-- don't call super
		--TODO: not calling super might break something down the road
		for i=1,#self.frames do
			self.frames[i]:Cleanup()
		end
	end
end