--TODO: move to Menus/Buttons/Button.lua?

--TODO: something in ResuableButtonFrames doesn't reset properly; white box when we mouseover it, sometimes

--TODO: rename drawable.createframe to createframes, plural?
--TODO: replace drawable.width with drawable.size?

local super=TRAININGGROUNDS_GameObject
TRAININGGROUNDS_Button = TRAININGGROUNDS_inheritsFrom(super)
local class=TRAININGGROUNDS_Button

-- function class:SetFrame()
	-- --don't call super
	-- self.frame=TRAININGGROUNDS_ReusableButtonFrames.getFrame()
	-- --TODO: set frame level	
	-- self.frame:SetWidth(400);self.frame:SetHeight(50)		
	-- self.textframe=TRAININGGROUNDS_ReusableFrames.getFrame()
	-- self.textframe.tag="MenuButton textframe"
	-- self.textframe:SetParent(self.frame)
	-- self.textframe:SetAllPoints(self.frame)	
-- end

function class:SetCustomInfo()
	super.SetCustomInfo(self)
	self.alpha=1
end

function class:SetDrawable()	
	--self.drawable=TRAININGGROUNDS_Drawable_Button:new()
	--self.drawable=TRAININGGROUNDS_Drawable_SpellButton:new()
	self.drawable=TRAININGGROUNDS_Drawable_MenuButton:new()
	self.drawable:Setup(self,self.environment)

end

-- function TRAININGGROUNDS_MenuButton:SetAppearance()
-- --print("TRAININGGROUNDS_MenuButton:SetAppearance()")
	-- self.frame:Show()
	-- --!!!
	-- --self.frame.texture:SetTexture("Interface\\AddOns\\TrainingGrounds\\Assets\\Graphics\\placeholder_logo.tga")
	-- --TODO: use Button:SetHighlightTexture instead
	-- self.frame.texture:Show()	
	
	-- --self.frame.texture:SetTexture(1,1,1,1)
	-- self.alignment="TOPLEFT"
	
	-- self.border=TRAININGGROUNDS_BorderGraphic.new()
	-- self.border:setup(self.frame)
	
-- end

function class:SetClickability()
	-- override. don't call super when overriding
	self.clickable=true	
	self.clickarea={}
	self.clickarea.x=0; self.clickarea.y=0; self.clickarea.width=self.frame:GetWidth(); self.clickarea.height=self.frame:GetHeight()
end

-- function class:Resize(wid,hgt)
	-- self.frame:SetWidth(wid)
	-- self.frame:SetHeight(hgt)
	-- self.border:Redraw(self.frame)
	-- self:SetClickability()
-- end

function class:SetText(text)	
	--TODO: self.drawable:SetText
	self.drawable.frame.fontstring:SetJustifyH("CENTER")
	self.drawable.frame.fontstring:SetText(text)
	self.drawable.frame:Show()
	self.drawable.frame.fontstring:Show()
end


function class:Step(elapsed)
	super.Step(self,elapsed)

	--ActionButton_HideOverlayGlow(self.frame)
	
	--TODO: apply this to all GameObjects?	
	if(self.currentalpha==nil)then
		self.currentalpha=self.drawable.frame:GetAlpha()
	end
	if(self.targetalpha==nil)then
		self.targetalpha=self.currentalpha
	end
	if(self.alphachangerate==nil)then
		self.alphachangerate=3
	end	
	if(self.targetalpha>self.currentalpha)then
		self.currentalpha=self.currentalpha+self.alphachangerate*elapsed
		if(self.currentalpha>self.targetalpha)then self.currentalpha=self.targetalpha end
		self.drawable.frame:SetAlpha(self.currentalpha)
	elseif(self.targetalpha<self.currentalpha)then
		self.currentalpha=self.currentalpha-self.alphachangerate*elapsed
		if(self.currentalpha<self.targetalpha)then self.currentalpha=self.targetalpha end
		self.drawable.frame:SetAlpha(self.currentalpha)
	end	
end

-- function class:draw()
	-- --TODO: replace with button:sethighlighttexture
	-- if(self.ismouseovered==true)then
		-- self.frame.texture:SetTexture(1,1,1,.25)
	-- else
		-- self.frame.texture:SetTexture(1,1,1,0)
	-- end
		
	-- TRAININGGROUNDS_GameObject.draw(self)
-- end


-- function class:Cleanup()
	-- TRAININGGROUNDS_GameObject.Cleanup(self)
	-- -- Button frame will be removed in GameObject.Cleanup
	
	-- -- but we still need to remove textframe from here
	-- self.textframe:Cleanup()
	
	-- self.border:Cleanup()	
	
-- end


---------------------------------------
---------------------------------------
---------------------------------------
---------------------------------------
---------------------------------------
local super=TRAININGGROUNDS_Drawable
TRAININGGROUNDS_Drawable_Button=TRAININGGROUNDS_inheritsFrom(super)
local class=TRAININGGROUNDS_Drawable_Button
function class:CreateFrame()
	--self.frame=TRAININGGROUNDS_ReusableButtonFrames:GetFrame()
	self.frame=TRAININGGROUNDS_ReusableFrames:GetFrame()
	self.frame:Show()
end

-- function class:ArrangeFrame(parentanchor,x,y,wid,hgt,yaw,pitch,zoom)
	-- TRAININGGROUNDS_Drawable.ArrangeFrame(self,parentanchor,x,y,wid,hgt,yaw,pitch,zoom)
	-- print("calling framevisibility check on",self,"'s frame")
	-- TRAININGGROUNDS_FrameVisibilityCheck(self.frame)	
-- end

---------------------------------------
---------------------------------------
---------------------------------------
---------------------------------------
---------------------------------------


do
	local super=TRAININGGROUNDS_Drawable_Button
	TRAININGGROUNDS_Drawable_MenuButton=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_Drawable_MenuButton
	

	function class:CreateFrame()
		--override; don't call super while overriding
		self.frame=TRAININGGROUNDS_ReusableButtonFrames:GetFrame()
		--self.frame.texture:Show()
		self.left=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.right=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.top=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.bottom=TRAININGGROUNDS_ReusableFrames:GetFrame()
	end
	
	local function QuickBorderSetup(frame,parent,point1string,point2string,sizefunction)
		--TODO: we don't need to do this here, but some manually-drawn borders, like resource bars,
			-- need to adjust border when camera is zoomed out	
		frame:Show()		
		frame:SetParent(parent)
		frame.texture:Show()
		frame.texture:SetColorTexture(1,1,1,1)
		--print(sizefunction,frame.SetWidth)
		frame:SetPoint(point1string,parent,point1string)
		frame:SetPoint(point2string,parent,point2string)		
		sizefunction(frame,3)
		frame:SetAlpha(1)
	end
	
	function class:SetFrameAppearance()
		self.frame.texture:Show()
		self.frame.texture:SetColorTexture(0,0,0,0.5)
		QuickBorderSetup(self.left,self.frame,"TOPLEFT","BOTTOMLEFT",self.left.SetWidth)
		QuickBorderSetup(self.right,self.frame,"TOPRIGHT","BOTTOMRIGHT",self.right.SetWidth)
		QuickBorderSetup(self.top,self.frame,"TOPLEFT","TOPRIGHT",self.top.SetHeight)
		QuickBorderSetup(self.bottom,self.frame,"BOTTOMLEFT","BOTTOMRIGHT",self.left.SetHeight)
	end	
	
	function class:Cleanup()
		self.frame:Cleanup()
		self.left:Cleanup()
		self.right:Cleanup()
		self.top:Cleanup()
		self.bottom:Cleanup()
		
	end		
end
