do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_Simple3DCameraNameplate=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_Simple3DCameraNameplate
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alpha=1		
		self.owner=nil	--owner must be set by creator function
	end
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_Drawable_Simple3DCameraNameplate.new()
		self.drawable:Setup(self,self.environment)
		self:SetText("ERROR")	--!!!
	end

	function class:SetText(text)	
		-- --TODO: self.drawable:SetText
		-- self.drawable.frame.fontstring:SetJustifyH("CENTER")
		-- self.drawable.frame.fontstring:SetText(text)		
		-- self.drawable.frame:Show()
		-- self.drawable.frame.fontstring:Show()
		-- self.drawable.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE")
	end
	
	function class:Select(value)
		self.drawable:Select(value)
	end	
	
	-- function class:CreateAssociatedObjects()
		-- -- self.bosshp=TRAININGGROUNDS_GameObject_ResourceBar:new()
		-- -- self.bosshp:Setup(self.environment,self)
		-- --TODO: not sure how to handle this gracefully.
		-- -- extra parameter in resourcebar:setup?
		-- -- self.bosshp.drawable:Cleanup()
		-- -- self.bosshp.drawable=TRAININGGROUNDS_Drawable_ResourceBar_Simple.new()
		-- -- self.bosshp.drawable:Setup(self.bosshp,self.bosshp.environment)
	-- end

end

do
	local super=TRAININGGROUNDS_Drawable
	TRAININGGROUNDS_Drawable_Simple3DCameraNameplate=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_Drawable_Simple3DCameraNameplate
	
	function class:CreateFrame()
		self.frame=TRAININGGROUNDS_ReusableButtonFrames:GetFrame()
		self.frame:Show()
		self.fill=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.fill:Show()
		self.textframe=TRAININGGROUNDS_ReusableFrames:GetFrame()
		self.textframe:Show()
		self.frames={}
		tinsert(self.frames,self.frame)
		tinsert(self.frames,self.fill)
		tinsert(self.frames,self.textframe)
	end
	
	function class:SetFrameAppearance()
	
		-- Old screen size:
		self.healthbarwidth=150		--prolonged fights
		self.healthbarheight=30

	
		-- --override; don't call super while overriding
		
		self.frame:Show()
		self.frame:SetSize(self.healthbarwidth,self.healthbarheight)
		self.frame.texture:Show()		
		self.frame.texture:SetAllPoints(self.frame)
		
		--TODO: mouse input is being stolen by some other frame -- probably the camera input frame
			-- but why aren't HUD buttons affected?
		self.frame:SetScript("OnMouseDown",function()
			self.owner.environment:SelectMobiles({self.owner})
		end)		
		self.frame:EnableMouse(true)
		
		self.fill:SetParent(self.frame)
		self.fill:SetSize(self.healthbarwidth*0.3,self.healthbarheight)
		self.fill:SetPoint("LEFT",self.frame,"LEFT",0,0)
		self.fill.texture:Show()
		self.fill.texture:SetAllPoints(self.fill)	
			
		self.textframe:SetParent(self.fill)
		self.textframe:SetAllPoints(self.frame)
		self.textframe.fontstring:Show()
		self.textframe.fontstring:SetFont("Fonts\\FRIZQT__.TTF",14,"OUTLINE")
		self.textframe.fontstring:SetText("Jaina")
		
		self:Select(false)

	end

	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.nameplateframelayer
	end
	
	

	function class:Select(value)
		if(value==true)then
			--print("true")
			self.frame.texture:SetColorTexture(0.5,0.125,0.125,0.75)
			self.fill.texture:SetColorTexture(1.0,0.0,0.0,0.9)	
		else
			--print("false")
			self.frame.texture:SetColorTexture(0.5,0.0,0.0,0.5)
			self.fill.texture:SetColorTexture(0.5,0.0,0.0,0.9)
		end
	end
	
	-- function class:SetFrameLevel()
		-- --override; don't call super while overriding
		-- if(self.frames)then
			-- for i=1,#self.frames do
				-- self.frames[i]:SetFrameLevel(self.framelayer.level)
			-- end
		-- end
		-- self.bar_fill:SetFrameLevel(self.framelayer.level+1)
		-- --self.frame:SetFrameLevel(self.framelayer.level)
	-- end
	
	function class:ArrangeFrame3D(cposoffsetvectorx,cposoffsetvectory,cposoffsetvectorz,cdist,clookatx,clookaty,clookatz,cangx,cangy,cangz)	
		--TODO: get nameplate clicks to work with standard environment!
		self.parentframe=self.environment.game.environment_hud.frame
	
		--override; don't call super when overriding
		self.frame:SetParent(self.parentframe)
		--print("Drawing",self.frame.name)
		-- if(self.frame.name=="TRAININGGROUNDS_ReusableFrame62")then
			-- print("Frame62's parent is",self.parentframe,self.frame:GetParent())
		-- end
		if(self.parentframe==UIParent)then		
			print("WARNING:",self.frame.name,"parent is UIParent")
		end
		if(self.frame:GetParent()==UIParent)then
			print("WARNING:",self.frame.name,"parent is UIParent")
		end
		self.frame:ClearAllPoints()
	
		local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)	
		
		local SCALE=30

		
		local cposx=cposoffsetvectorx*cdist+clookatx
		local cposy=cposoffsetvectory*cdist+clookaty
		local cposz=cposoffsetvectorz*cdist+clookatz
						local xdiff=self.x/yard-cposx
						local ydiff=self.z/yard-cposy		-- remember, cameraY is vertical, objY is depth
						local zdiff=self.y/yard-cposz
			--TODO: WHY DOES THIS WORK
		local x2,y2,tempZsort=TRAININGGROUNDS_MatrixMultiplicationRotation2(xdiff,ydiff,zdiff,cangx,cangy-math.pi/2,cangz)
			
		--print("Cpos:",cposx,cposy,cposz)
		
		--print("Before:",xdiff,ydiff,zdiff)
		--print("Cang:",cangx/math.pi,cangy/math.pi,cangz/math.pi)
		--print("After:",ignoreX,ignoreY,tempZsort)
		--TODO: nameplate sometimes sticks to wrong position.  wrong parent, scrollframe, or layer?
			-- (probably child frames aren't initialized properly)
		local far=50*yard
		x2,y2=TRAININGGROUNDS_SECRET35_PerspectiveTransform(x2,y2,tempZsort,far)
		self.frame:SetPoint(self.anchor,self.parentframe,"CENTER",x2*SCALE,y2*SCALE)	
		
		TEMP=self
	end
	
	--TODO: move to math or utils
	function TRAININGGROUNDS_PerspectiveTransform(x,y,z,far)
		-- Z is depth axis.  (TODO: this is still inconsistent with a few things)
		if(z<-far/2)then z=-far/2 end
		local x2,y2
		x2=x*far/(z+far)
		y2=y*far/(z+far)		
		--print(x2,y2)
		return x2,y2
	end
	

	
	function unittest()
		-- print("Testing 1,0,0, 0,0,0.  Expected: 1,0,0")	--looking forward, obj to right
		-- print(TRAININGGROUNDS_MatrixMultiplicationRotation(1,0,0, 0,0,0))
		
		-- print("Testing 0,-1,0, -*.25,*0,0.  Expected: 0,0,1") -- look half down, obj below
		-- print(TRAININGGROUNDS_MatrixMultiplicationRotation(0,-1,0, math.pi*-.25,math.pi*0,0))		

		-- print("Testing 0,-1,0, -*.25,*.25,0.  Expected: 0,0,1") -- look half down and spin, obj below, no change in appearance
		-- print(TRAININGGROUNDS_MatrixMultiplicationRotation(0,-1,0, math.pi*-.25,math.pi*.25,0))		
		
		print("Testing 0,0,1 -*.5,0,0.  Expected: 0,1,0") -- look down, obj in front
		print(TRAININGGROUNDS_MatrixMultiplicationRotation2(0,0,1, math.pi*-0.5,math.pi*0,0))
		
		print("Testing 0,0,1 -*.5,*.25,0.  Expected: ?,?,0") -- look down and spin, obj in front
		print(TRAININGGROUNDS_MatrixMultiplicationRotation2(0,0,1, math.pi*-0.5,math.pi*0.25,0))
				
		-- print("Testing 0,-1,1, -*.5,0,0.  Expected: 0,1,1") -- look down, obj below and forward
		-- print(TRAININGGROUNDS_MatrixMultiplicationRotation(0,-1,1, math.pi*-.5,0,0))	

		-- print("Testing 0,-1,1, -*.5,*.5,0.  Expected: 1,0,1") -- look down and spin, obj below and forward
		-- print(TRAININGGROUNDS_MatrixMultiplicationRotation(0,-1,1, math.pi*-.5,math.pi*.5,0))			
		
		-- print("Testing 0,-1,1, -*.5,*.25,0.  Expected: ?,?,1") -- look down and halfspin, obj below and forward
		-- print(TRAININGGROUNDS_MatrixMultiplicationRotation(0,-1,1, math.pi*-.5,math.pi*.25,0))			
	end
end
