local super=TRAININGGROUNDS_Projectile_StandardGielenorianMissile
TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack = TRAININGGROUNDS_inheritsFrom(super)
local class=TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack

function class:SetDrawable()
	local i=math.floor(math.random()*7+1)
	if(i==1)then
		self.drawable=TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_SolarWrath.new()
	elseif(i==2)then
		self.drawable=TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_CobraShot.new()
	elseif(i==3)then
		self.drawable=TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_Fireball.new()
	elseif(i==4)then
		self.drawable=TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_ChiOrbit.new()
	elseif(i==5)then
		self.drawable=TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_HolyWrath.new()
	elseif(i==6)then
		self.drawable=TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_VoidBolt.new()
	elseif(i==7)then		
		self.drawable=TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_Demonbolt.new()
	end
	self.drawable:Setup(self,self.environment)
end

--------------------------

local super=TRAININGGROUNDS_Drawable_SpellEffect
TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_SolarWrath = TRAININGGROUNDS_inheritsFrom(super)
local class=TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_SolarWrath
function class:SetCustomInfo()
	super.SetCustomInfo(self)
	self.anchor="CENTER"
	self.selected=false
	self.modelfilename="spells/cfx_druid_solarwrath_missile.m2"	
	self.modelfileid=1513210	
	self.scale3D=0.25	--TODO: probably move to modelinfo	
	self.positionmultiplier=1/self.scale3D	--TODO: move to modelinfo
	self.defaultanimation=127
end

--------------------------

local super=TRAININGGROUNDS_Drawable_SpellEffect
TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_CobraShot = TRAININGGROUNDS_inheritsFrom(super)
local class=TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_CobraShot
function class:SetCustomInfo()
	super.SetCustomInfo(self)
	self.anchor="CENTER"
	self.selected=false
	self.modelfilename="spells/cfx_hunter_cobrashot_missile.m2"
	self.modelfileid=1560266
	self.scale3D=0.25	--TODO: probably move to modelinfo	
	self.positionmultiplier=1/self.scale3D	--TODO: move to modelinfo
	self.defaultanimation=127
end

--------------------------

local super=TRAININGGROUNDS_Drawable_SpellEffect
TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_Fireball = TRAININGGROUNDS_inheritsFrom(super)
local class=TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_Fireball
function class:SetCustomInfo()
	super.SetCustomInfo(self)
	self.anchor="CENTER"
	self.selected=false
	self.modelfilename="spells/cfx_mage_fireball_missile.m2"
	self.modelfileid=1327009
	self.scale3D=0.125	--TODO: probably move to modelinfo	
	self.positionmultiplier=1/self.scale3D	--TODO: move to modelinfo
	self.defaultanimation=127
end

--------------------------

local super=TRAININGGROUNDS_Drawable_SpellEffect
TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_ChiOrbit = TRAININGGROUNDS_inheritsFrom(super)
local class=TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_ChiOrbit
function class:SetCustomInfo()
	super.SetCustomInfo(self)
	self.anchor="CENTER"
	self.selected=false	
	self.modelfilename="spells/cfx_monk_chiorbit_missile.m2"
	self.modelfileid=1536474
	self.scale3D=1.0	--TODO: probably move to modelinfo	
	self.positionmultiplier=1/self.scale3D	--TODO: move to modelinfo
	self.defaultanimation=127
end

--------------------------

local super=TRAININGGROUNDS_Drawable_SpellEffect
TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_HolyWrath = TRAININGGROUNDS_inheritsFrom(super)
local class=TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_HolyWrath
function class:SetCustomInfo()
	super.SetCustomInfo(self)
	self.anchor="CENTER"
	self.selected=false	
	self.modelfilename="spells/cfx_paladin_holywrath_missile.m2"
	self.modelfileid=1368708
	self.scale3D=0.5	--TODO: probably move to modelinfo	
	self.positionmultiplier=1/self.scale3D	--TODO: move to modelinfo
	self.defaultanimation=127
end

--------------------------

local super=TRAININGGROUNDS_Drawable_SpellEffect
TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_VoidBolt = TRAININGGROUNDS_inheritsFrom(super)
local class=TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_VoidBolt 
function class:SetCustomInfo()
	super.SetCustomInfo(self)
	self.anchor="CENTER"
	self.selected=false	
	self.modelfilename="spells/cfx_priest_voidbolt_missile.m2"	
	self.modelfileid=1693741
	self.scale3D=0.125	--TODO: probably move to modelinfo	
	self.positionmultiplier=1/self.scale3D	--TODO: move to modelinfo
	self.defaultanimation=127
end

--------------------------

local super=TRAININGGROUNDS_Drawable_SpellEffect
TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_Demonbolt = TRAININGGROUNDS_inheritsFrom(super)
local class=TRAININGGROUNDS_Projectile_SampleDistractingRangedAttack_Drawable_Demonbolt 
function class:SetCustomInfo()
	super.SetCustomInfo(self)
	self.anchor="CENTER"
	self.selected=false	
	self.modelfilename="spells/cfx_warlock_demonbolt_missile.m2"
	self.modelfileid=2065722
	self.scale3D=0.125	--TODO: probably move to modelinfo	
	self.positionmultiplier=1/self.scale3D	--TODO: move to modelinfo
	self.defaultanimation=127
end