
do
	--TODO LATER: does RestartGx help us anywhere (not necessarily here)
	
	-- TODO LATER: cvar override makes a fairly strong case for traininggrounds to be a singleton class
 	private_TRAININGGROUNDS_CVars = {}
	local class=private_TRAININGGROUNDS_CVars
	class.__index = class	
	
	function class.new()
		local self=setmetatable({}, class)
		return self
	end
	
	function class:Setup()
		self.cvarnames={}
		tinsert(self.cvarnames,"enableMouseSpeed")
		tinsert(self.cvarnames,"mouseSpeed")
		self.cvarvalues={}
	end
	
	function class:SaveAll()
		for i=1,#self.cvarnames do
			local cvarname=self.cvarnames[i]			
			self.cvarvalues[cvarname]=GetCVar(cvarname)
			--print("Saving",cvarname,self.cvarvalues[cvarname])
		end
	end
	
	function class:Override(cvarname,value)
		SetCVar(cvarname,value)
	end
	
	function class:Restore(cvarname)
		SetCVar(cvarname,self.cvarvalues[cvarname])
	end
	
	function class:RestoreAll()	
		for i=#self.cvarnames,1,-1 do
			local cvarname=self.cvarnames[i]
			--print("Restoring",cvarname,self.cvarvalues[cvarname])
			SetCVar(cvarname,self.cvarvalues[cvarname])
		end	
	end
	
	TRAININGGROUNDS_CVars=private_TRAININGGROUNDS_CVars.new()
	TRAININGGROUNDS_CVars:Setup()
	
end
