

do
	local super=TRAININGGROUNDS_Mobile
	TRAININGGROUNDS_MEKKATORQUE_Mobile_Mekkatorque=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_MEKKATORQUE_Mobile_Mekkatorque

	function class:GetName()
		--override, don't call super
		return "Mekkatorque (mobile) "..tostring(self.id)
	end
	

	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		
		--self.TEMP_TAG=true
		
		self.nameplatename="Mekkatorque"
		self.basemovespeed = 1.5 * TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(7.0)
		self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*10.0
		--self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*4.0
		--self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*3.0
		--self.baseturnspeed=2.0	
		--self.baseturnspeed_3D=2.0	
		self.faction=TRAININGGROUNDS_Factions.ENEMY
		
		--set after calling setup: 
		self.groupdancemodule=nil	-- (used when spells create further objects)		
	end
	
	function class:CreateAI()
		self.ai=TRAININGGROUNDS_AI_Boss.new()
		self.ai:Setup(self,environment)
	end		
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_MEKKATORQUE_Drawable_Mekkatorque.new()
		--self.drawable=TRAININGGROUNDS_MEKKATORQUE_SparkBot_Drawable.new()
		self.drawable:Setup(self,self.environment)
	end
	
	-- function class:CreateCombatModule()
		-- self.combat=TRAININGGROUNDS_MEKKATORQUE_CombatModule_Mekkatorque.new()
		-- self.combat:Setup(self)
	-- end
end

do
	TRAININGGROUNDS_MEKKATORQUE_ANIMATION_LIST={}
	local followthrough=TRAININGGROUNDS_AnimationSequence_QuickSetup(TRAININGGROUNDS_MEKKATORQUE_ANIMATION_LIST,"ChannelCastDirected_Followthrough",124,nil,TRAININGGROUNDS_ANIMATION_PRIORITY.ENDCAST,1.0)



	if(not TRAININGGROUNDS_ModelInfos.Mekkatorque)then
		local mi
		mi=TRAININGGROUNDS_ModelInfo.new()
		mi:Setup()
		mi.displayid=89236
		mi.cameradistance=15
		mi.size=300
		mi.shadowsize=mi.size*0.75
		
		mi.clickboxx=0
		mi.clickboxy=-5
		mi.clickboxwidth=60
		mi.clickboxheight=80
		
		TRAININGGROUNDS_ModelInfos.Mekkatorque=mi
		TRAININGGROUNDS_ModelInfos:Add(mi.displayid,mi)
	end

	local super=TRAININGGROUNDS_Drawable_CharacterModel
	TRAININGGROUNDS_MEKKATORQUE_Drawable_Mekkatorque = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_MEKKATORQUE_Drawable_Mekkatorque 
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.scale3D=1.5	--TODO: move to modelinfo
		--self.positionmultiplier=0.9
		self.positionmultiplier=1/self.scale3D
	end
	
	function class:SetFrameAppearance()	
		self.modelinfo=TRAININGGROUNDS_ModelInfos.Mekkatorque
		self.frame:SetDisplayInfo(self.modelinfo.displayid)	
	end
	
	-- function class:Get3DPositionCoords()
		-- local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
		-- return self.x,self.y,self.z+yard*0.25
	-- end
end