

do
	local super=TRAININGGROUNDS_Scenario
	TRAININGGROUNDS_OPULENCE_Scenario_FlamesOfPunishment = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_OPULENCE_Scenario_FlamesOfPunishment

	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)	
	
	function class:Populate()
		super.Populate(self)				
			
		self:CreateBossController()
		
		local currentplayer=self.raid.rdps[1]
		self.controls:SetPlayer(currentplayer)
		currentplayer:SetPlayerAppearance()
		self.player=currentplayer
		local relevant=TRAININGGROUNDS_Aura_PlayerControlled.new()
		relevant:Setup(currentplayer.combat,currentplayer.combat,currentplayer:GetLocalTime())			

		self.flamesofpunishment.groupdancemodule:GetIntoInitialPosition()
		
		--local YDIFF=100
		local XDIFF=125
		local YDIFF=0
		
		self.startbuttons={}
		--!!!
		local startbutton	
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2-XDIFF*2.7
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-200+YDIFF
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Heroic")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self:SetMode(1)
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)
		local startbutton	
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2-XDIFF
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-200+YDIFF
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Heroic\r(Overload)")
		startbutton.drawable.frame:SetScript("OnClick",function()					
					self:SetMode(2)			
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)		
		local startbutton	
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2+XDIFF
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-200-YDIFF
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Mythic")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self:SetMode(3)
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)		

		local startbutton	
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2+XDIFF*2.7
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-200-YDIFF
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Mythic\r(Overload)")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self:SetMode(4)			
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)				

		local startbutton	
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2-250
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-350
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Crush Left")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self:SetMode(6)		-- 6 is LEFT
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)			
		
		local startbutton	
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2-35
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-350
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Crush Right")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self:SetMode(5)		-- 5 is RIGHT
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)			
		
		local startbutton	
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2+250
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-350
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Mystery!")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self:SetMode(8)
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)				
	end
	
	function class:SetMode(mode)
		self.flamesofpunishment.groupdancemodule.mode_choice=mode
		if(mode==1)then
			self.flamesofpunishment.groupdancemodule.cast_time=4.0
			self.flamesofpunishment.groupdancemodule.channel_time=6.5
			self.flamesofpunishment.groupdancemodule.total_ticks=12
			self.flamesofpunishment.groupdancemodule.conewidth=math.pi*2/6
			self.flamesofpunishment.groupdancemodule.flamecount=1
			self.flamesofpunishment.groupdancemodule.spin_per_tick=math.pi*2/12
			self.flamesofpunishment.groupdancemodule.turnspeed=2.0
		elseif(mode==2)then
			self.flamesofpunishment.groupdancemodule.cast_time=3.0
			self.flamesofpunishment.groupdancemodule.channel_time=6.5
			self.flamesofpunishment.groupdancemodule.total_ticks=12
			self.flamesofpunishment.groupdancemodule.conewidth=math.pi*2/2
			self.flamesofpunishment.groupdancemodule.flamecount=3
			self.flamesofpunishment.groupdancemodule.spin_per_tick=math.pi*2/12		
			self.flamesofpunishment.groupdancemodule.turnspeed=2.0		
		elseif(mode==3)then
			self.flamesofpunishment.groupdancemodule.cast_time=4.0
			self.flamesofpunishment.groupdancemodule.channel_time=6.5
			self.flamesofpunishment.groupdancemodule.total_ticks=11
			self.flamesofpunishment.groupdancemodule.conewidth=math.pi*2/6
			self.flamesofpunishment.groupdancemodule.flamecount=1
			self.flamesofpunishment.groupdancemodule.spin_per_tick=math.pi*2/7*(1.0) --TODO: 0.95 or similar
			self.flamesofpunishment.groupdancemodule.turnspeed=4.0
		elseif(mode==4)then
			self.flamesofpunishment.groupdancemodule.cast_time=4.0
			self.flamesofpunishment.groupdancemodule.channel_time=6.5
			self.flamesofpunishment.groupdancemodule.total_ticks=11
			self.flamesofpunishment.groupdancemodule.conewidth=math.pi*2/2
			self.flamesofpunishment.groupdancemodule.flamecount=3
			self.flamesofpunishment.groupdancemodule.spin_per_tick=math.pi*2/7*(1.0) --TODO: 0.95 or similar		
			self.flamesofpunishment.groupdancemodule.turnspeed=4.0		
		elseif(mode==5 or mode==6)then
			-- 6: turn left, 5: turn right		(positive offset turns LEFT)
			local offset=math.random()*math.pi/4
			--offset=math.pi/2--!!!
			local direction=(mode-5)*2-1
			self.flamesofpunishment.groupdancemodule.slamoffset=offset
			self.flamesofpunishment.groupdancemodule.slamdirection=direction
		elseif(mode==7)then	--1/7 chance of Liquid Gold
				-- do nothing; we already set mode choice			
		elseif(mode==8)then
			local r=math.floor(math.random()*7)+1
			self:SetMode(r)
		end
	end
	
	

	function class:SetCamera()
		self.environment.game.environment_gameplay.cameramanager.camera=TRAININGGROUNDS_Camera3D.new()
		self.environment.game.environment_gameplay.cameramanager.camera:Setup(self.environment.game.environment_gameplay)
	end	

	--TODO: somehow connect camera+playercontrols, since they're usually codependent
	function class:CreatePlayerControls()
		local controls = TRAININGGROUNDS_ScenarioPlayerControls_CharacterMode_3D.new()
		controls:Setup(self.environment,self)			
		self.controls=controls
	end
	
	function class:CreateBossController()
		self.flamesofpunishment=TRAININGGROUNDS_OPULENCE_BossController_FlamesOfPunishment.new()
		--TODO: at this point it becomes very awkward that scenario.environment is not scenario.environment_gameplay
		self.flamesofpunishment:Setup(self.environment.game.environment_gameplay,self)
		self.flamesofpunishment:CreateBoss()		
		self.flamesofpunishment.groupdancemodule.bosscontroller=self.flamesofpunishment
		self.flamesofpunishment.groupdancemodule:PopulateDefaultRaid(self.environment.game.environment_gameplay)
	end
	
	function class:OnStartButton()
		for i=1,#self.startbuttons do
			self.startbuttons[i].visible=false	
			self.startbuttons[i].drawable.frame:EnableMouse(false)
		end
		self.flamesofpunishment.groupdancemodule:StartTestCycle()
	end
	
	function class:ShowButtons()
		for i=1,#self.startbuttons do
			self.startbuttons[i].visible=true	
			self.startbuttons[i].drawable.frame:EnableMouse(true)
		end	
	end

	function class:OnEscapeKey()
		self.environment.game:LoadScenarioByClass(TRAININGGROUNDS_Scenario_Menu)
	end
	
	function class:PostMove(elapsed)
		super.PostMove(elapsed)
		--print("PostMove",self.player)
		if(self.player)then
			local dist=math.sqrt(self.player.x*self.player.x+self.player.y*self.player.y)
			local MAX_DIST=yard*18
			if(dist>MAX_DIST)then
				local unitvectorx=self.player.x/dist
				local unitvectory=self.player.y/dist
				self.player.x=unitvectorx*MAX_DIST
				self.player.y=unitvectory*MAX_DIST
			end
		end
	end
	
end
