--TODO: hitdetection from impact object rather than telegraph object

do

	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	local REDX="\124TInterface\\TargetingFrame\\UI-RaidTargetingIcon_7:12\124t"
	local INTRO_TIME_MULTIPLIER=1.0

	TRAININGGROUNDS_ORGOZOA_CustomDanceEventType={}
	local i=0
	i=i+1;TRAININGGROUNDS_ORGOZOA_CustomDanceEventType.SUCCESS=i
	i=i+1;TRAININGGROUNDS_ORGOZOA_CustomDanceEventType.HIT_BY_DRIBBLINGICHOR=i

	
	local super=TRAININGGROUNDS_GroupDanceModule	
	TRAININGGROUNDS_ORGOZOA_GroupDanceModule_Orgozoa=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_ORGOZOA_GroupDanceModule_Orgozoa
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.successesinarow=0
		self.mode_choice=nil
		self.playerisdead=false
	end


	
	function class:PopulateDefaultRaid(environment)	
		self.environment=environment

		self.orgozoa=self.bosscontroller.orgozoa	
		self.orgozoa.groupdancemodule=self
	

		self.raid:CreatePlayers(environment,0,0,0,1)
		--self.raid:MakeAllPlayersIrrelevant()
		
		-- -- for now, no autocasts.
		-- for i=1,#self.raid.players do
			-- self.raid.players[i].combat.autocastmodule:Cleanup()
			-- self.raid.players[i].combat.autocastmodule=nil
		-- end
	
		--TODO: move raid roles to another function
		self.tanks=self.raid.tanks
		self.currenttankindex=1
		self.rdps=self.raid.rdps
		self.player=self.raid.rdps[1]
							
		self:SetupInitialCameraFocus()
	end
	
	--TODO: maybe baseline, maybe not
	function class:SetupInitialCameraFocus()
		local camera=self.player.environment.cameramanager.camera
		tinsert(camera.focus,self.player)
	end

	
	function class:GetIntoInitialPosition()							
		self.orgozoa.x=yard*0
		self.orgozoa.y=yard*0
				
		self.player.x=0
		self.player.y=yard*-9
		self.player.currentfacing=math.pi/2	-- facing "north" for 3D camera
		--self.player.currentfacing_3D=self.player.currentfacing
		--self.player.targetfacing_3D=self.player.currentfacing
		self.scenario.environment.game.environment_gameplay.cameramanager.camera.cangy=self.player.currentfacing

		self.scenario.player=self.player
		self.player.groupdancemodule=self

		for i=1,#self.raid.players do
			self.raid.players[i]:SnapFacingToTargetMobile(self.orgozoa)
			if(self.raid.players[i]~=self.player)then self.raid.players[i].visible=false end
		end
		-- self.orgozoa:SnapFacingToTargetMobile(self.raid.tanks[1])
		self.orgozoa.x=0
		self.orgozoa.y=yard*10
		self.orgozoa.drawable:SetAnimation(TRAININGGROUNDS_ANIMATION_LIST.ReadyUnarmed)
	end
	
	function class:StartDancing()
		-- TODO: for some reason we're not using this function when we really should be
	end
	
	function class:StartTestCycle()
		self:ResetPlayerDeathChecks()
		local totaltime=0

		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+0.25
		event.time=self.scenario.localtime+totaltime	
		event.execute=function() 
			self:ResetPlayerDeathChecks()			

							
		end
		tinsert(self.timedevents,event)	
		
		
		self.offsetdist=math.random()*yard*6
		self.offsetangle=math.random()*math.pi*2
		self.offsetx=math.cos(self.offsetangle)*self.offsetdist
		self.offsety=math.sin(self.offsetangle)*self.offsetdist
		local BASE_SPREAD=yard*13
		
		-- self:QuickTelegraph(0,0)
		-- self:QuickTelegraph(0,-yard*12)
		
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+0.25
		event.time=self.scenario.localtime+totaltime
		event.execute=function()				
				for x=-2,2 do
					for y=-2,2 do
						local x2=x*0.7
						local y2=y
						if(x%2==0)then y2=y-0.5 end
						local x3=x2*BASE_SPREAD+self.offsetx
						local y3=y2*BASE_SPREAD+self.offsety		
						local dist=math.sqrt(x3*x3+y3*y3)
						if(dist<=yard*18)then
							self:QuickTelegraph(x3,y3)
						end
					end
				end
			end;tinsert(self.timedevents,event)			
			
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+3+.5
		event.time=self.scenario.localtime+totaltime
		event.execute=function()				
				for x=-2,2 do
					for y=-2,2 do
						local x2=x*0.7
						local y2=y
						if(x%2~=0)then y2=y-0.5 end
						local x3=x2*BASE_SPREAD+self.offsetx
						local y3=y2*BASE_SPREAD+self.offsety		
						local dist=math.sqrt(x3*x3+y3*y3)
						if(dist<=yard*18)then
							self:QuickTelegraph(x3,y3)
						end
					end
				end
			end;tinsert(self.timedevents,event)		
			
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+3+.5
		event.time=self.scenario.localtime+totaltime
		event.execute=function()				
				for x=-2,2 do
					for y=-2,2 do
						local x2=x*0.7
						local y2=y
						if(x%2==0)then y2=y-0.5 end
						local x3=x2*BASE_SPREAD+self.offsetx
						local y3=y2*BASE_SPREAD+self.offsety		
						local dist=math.sqrt(x3*x3+y3*y3)
						if(dist<=yard*18)then
							self:QuickTelegraph(x3,y3)
						end
					end
				end
			end;tinsert(self.timedevents,event)			

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+3+1.5
		event.time=self.scenario.localtime+totaltime
		event.execute=function() 		
			local message
			if(self.playerisdead)then
				self.successesinarow=0
				message="Try again..."
			else
				self.successesinarow=self.successesinarow+1
				message="OK!"
			end
			TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,2.0,false)
		end
		tinsert(self.timedevents,event)					

		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+1
		event.time=self.scenario.localtime+totaltime
		event.execute=function() 		
			if(	self.successesinarow>1)then
				local message="("..tostring(self.successesinarow).." in a row)"
				TRAININGGROUNDS_FakeDBM_RaidBossEmote(message,1.0,false)
			end			
		end
		tinsert(self.timedevents,event)				
								
		local event=TRAININGGROUNDS_TimedDanceEvent.new()
		totaltime=totaltime+3.0
		if(totaltime>0)then
			event.time=self.scenario.localtime+totaltime
			event.execute=function() 		
				self.scenario:ShowButtons()
			end
			tinsert(self.timedevents,event)
		end				


	end
	
	function class:QuickTelegraph(x,y)
		local telegraph=TRAININGGROUNDS_ORGOZOA_DribblingIchor_Telegraph_Decor.new()
		telegraph:Setup(self.environment);telegraph.x=x;telegraph.y=y
		telegraph.groupdancemodule=self
		local rim=TRAININGGROUNDS_ORGOZOA_DribblingIchor_Telegraph_Rim.new()
		local xoffset,yoffset
		offsetdist=math.random()*yard*0--!!!
		offsetangle=math.random()*math.pi*2
		xoffset=math.cos(offsetangle)*offsetdist
		yoffset=math.sin(offsetangle)*offsetdist
		rim:Setup(self.environment);rim.x=x+xoffset;rim.y=y+yoffset
	end
	
	
	function class:ResetPlayerDeathChecks()
		self.playerisdead=false
	end
	

	

		
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		
		--print(self.localtime)
		for i=#self.timedevents,1,-1 do
			local event=self.timedevents[i]
			if(self.localtime>=event.time)then	
				event.execute()
				tremove(self.timedevents,i)
			end
		end
	end
		
	function class:ReactToCustomDanceEvent(event)
		if(event.action==TRAININGGROUNDS_ORGOZOA_CustomDanceEventType.HIT_BY_DRIBBLINGICHOR)then
			self.playerisdead=true
			self.player.combat:FlashDamageFlash_Alert()
		end		
	end



	
	
	
	function class:GetEndOfCycleDelay()
		return 3.0
	end
	
	--TODO: cleanup (and cleanup on base groupdancemodule too?)
	function class:Cleanup()
		--TODO: NYI
	end
end
