
do
	local super=TRAININGGROUNDS_Scenario
	TRAININGGROUNDS_ORGOZOA_Scenario_Orgozoa = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_ORGOZOA_Scenario_Orgozoa

	
	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	
	function class:Populate()
		super.Populate(self)				
			
		self:CreateBossController()
		
		local currentplayer=self.raid.rdps[1]
		self.controls:SetPlayer(currentplayer)
		currentplayer:SetPlayerAppearance()
		local relevant=TRAININGGROUNDS_Aura_PlayerControlled.new()
		relevant:Setup(currentplayer.combat,currentplayer.combat,currentplayer:GetLocalTime())			

		self.orgozoa.groupdancemodule:GetIntoInitialPosition()
		
		
		local platformsize=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(100)		
		local arenaborder=TRAININGGROUNDS_ArenaBorder.new()
		arenaborder:Setup(self.environment.game.environment_gameplay)
		arenaborder.x=0;arenaborder.y=0
		arenaborder:SetSize(platformsize)
		arenaborder.drawable:SetColor(1,1,1,1,.125,.125,.125,1)
	
		
		
		
		--local YDIFF=100
		--local XDIFF=125
		local XDIFF=0
		local YDIFF=0		
		
		self.startbuttons={}
		--!!!

		tinsert(self.startbuttons,startbutton)		
		local startbutton	
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2-XDIFF
		startbutton.y=self.environment.game.window.frame:GetHeight()/2-200-YDIFF
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Start")
		startbutton.drawable.frame:SetScript("OnClick",function()
					--self.orgozoa.groupdancemodule.mode_choice=1
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)		



		
		local platformsize=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(100)		
		local arenaborder=TRAININGGROUNDS_ORGOZOA_Floor_Decor.new()
		arenaborder:Setup(self.environment.game.environment_gameplay)
		arenaborder.x=0;arenaborder.y=0
		
		
			

	end

	function class:SetCamera()
		self.environment.game.environment_gameplay.cameramanager.camera=TRAININGGROUNDS_Camera3D.new()
		--self.environment.game.environment_gameplay.cameramanager.camera=TRAININGGROUNDS_Camera_AdjustableZoom.new()
		self.environment.game.environment_gameplay.cameramanager.camera:Setup(self.environment.game.environment_gameplay)
	end	

	--TODO: somehow connect camera+playercontrols, since they're usually codependent
	function class:CreatePlayerControls()
		local controls = TRAININGGROUNDS_ScenarioPlayerControls_CharacterMode_3D.new()
		--local controls = TRAININGGROUNDS_ScenarioPlayerControls_CharacterMode.new()
		controls:Setup(self.environment,self)			
		self.controls=controls
	end
	
	function class:CreateBossController()
		self.orgozoa=TRAININGGROUNDS_ORGOZOA_BossController_Orgozoa.new()
		--TODO: at this point it becomes very awkward that scenario.environment is not scenario.environment_gameplay
		self.orgozoa:Setup(self.environment.game.environment_gameplay,self)
		self.orgozoa:CreateBoss()		
		self.orgozoa.groupdancemodule.bosscontroller=self.orgozoa
		self.orgozoa.groupdancemodule:PopulateDefaultRaid(self.environment.game.environment_gameplay)
	end
	
	function class:OnStartButton()
		for i=1,#self.startbuttons do
			self.startbuttons[i].visible=false	
			self.startbuttons[i].drawable.frame:EnableMouse(false)
		end
		self.orgozoa.groupdancemodule:StartTestCycle()
	end
	
	function class:ShowButtons()
		for i=1,#self.startbuttons do
			self.startbuttons[i].visible=true	
			self.startbuttons[i].drawable.frame:EnableMouse(true)
		end	
	end

	function class:OnEscapeKey()
		self.environment.game:LoadScenarioByClass(TRAININGGROUNDS_Scenario_Menu)
	end
	
	
	function class:PostMove(elapsed)
		super.PostMove(elapsed)
		--TODO: this should be part of ArenaBorder
		if(self.player)then
			local dist=math.sqrt(self.player.x*self.player.x+self.player.y*self.player.y)
			local MAX_DIST=yard*18/2
			if(dist>MAX_DIST)then
				local unitvectorx=self.player.x/dist
				local unitvectory=self.player.y/dist
				self.player.x=unitvectorx*MAX_DIST
				self.player.y=unitvectory*MAX_DIST
			end
		end
	end
	
	
	
end