do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Decor_ChargedSpearFloor=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Decor_ChargedSpearFloor	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=0
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Drawable_ChargedSpearFloor.new()
		self.drawable:Setup(self,self.environment)
	end	
end
do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Drawable_ChargedSpearFloor=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Drawable_ChargedSpearFloor
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false
		self.modelfilename="world/expansion07/doodads/dungeon/doodads/8du_nazmirraid_elevator01.m2"
		self.modelfileid=1829551
		
		self.scale3D=0.75	--TODO: probably move to modelinfo
		self.positionmultiplier=1/0.75	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.61	--TODO: move to modelinfo
		self.zsortoffset3D=10	--measured in yards.  TODO: move to modelinfo
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.floorframelayer
	end
end

do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Statue_Decor=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Statue_Decor
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.ysortable=true
	end	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Statue_Drawable.new()
		self.drawable:Setup(self,self.environment)
	end
end
do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Statue_Drawable=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Statue_Drawable
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false
		self.modelfileid=2923929	--"titanface01"
		self.scale3D=0.5	--TODO: probably move to modelinfo
		self.positionmultiplier=0.61/0.5	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.61	--TODO: move to modelinfo	
		self.defaultanimation=149
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end


do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Console_Decor=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Console_Decor
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.ysortable=true
	end	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Console_Drawable.new()
		self.drawable:Setup(self,self.environment)
	end
end
do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Console_Drawable=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Console_Drawable
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false
		self.modelfileid=2823397	--"titanconsole01"
		self.scale3D=0.5	--TODO: probably move to modelinfo
		self.positionmultiplier=0.61/0.5	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.61	--TODO: move to modelinfo	
		self.defaultanimation=149
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end

do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_PowerMeter_Decor=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_PowerMeter_Decor
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
	end	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_PowerMeter_Drawable.new()
		self.drawable:Setup(self,self.environment)
	end
end
do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_PowerMeter_Drawable=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_PowerMeter_Drawable
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false
		self.modelfileid=2997410	--"titanward_powermeter"
		self.scale3D=0.5	--TODO: probably move to modelinfo
		self.positionmultiplier=0.61/0.5	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.61	--TODO: move to modelinfo
		self.defaultanimation=149
		self.zsortoffset3D=7	--measured in yards
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.floorframelayer
	end
end

do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Ward01_Decor=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Ward01_Decor
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
	end	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Ward01_Drawable.new()
		self.drawable:Setup(self,self.environment)
	end
end
do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Ward01_Drawable=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Ward01_Drawable
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false
		self.modelfileid=2929757	--"controlzone01"
		self.scale3D=0.5	--TODO: probably move to modelinfo
		self.positionmultiplier=0.61/0.5	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.61	--TODO: move to modelinfo
		self.defaultanimation=149
		self.zsortoffset3D=7	--measured in yards
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.floorframelayer
	end
end