do
	local super=TRAININGGROUNDS_Sprite
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_ChargedSpearTimer=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_ChargedSpearTimer
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_Drawable_Sprite.new()		
		self.drawable:Setup(self,self.environment)
		self.drawable.ystretch=false
		self.drawable.width=100
		self.drawable.height=100	
		self.drawable.frame.texture:Show()
		self.drawable.frame.texture:SetTexture("interface\\icons\\ability_blackhand_marked4death.blp")
		self.drawable.frame.fontstring:Show()
		self.drawable.frame.fontstring:SetFont("Fonts\\FRIZQT__.TTF",48,"OUTLINE")
		self.drawable.frame.fontstring:SetText("13.0")
	end
	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.telegraphframelayer
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		local timenumber
		timenumber=string.format("%.1f",5.0-self.alivetime)
		if(self.alivetime>5)then
			timenumber=""
			self:Die()
		end
		self.drawable.frame.fontstring:SetText(timenumber)
	end
end



do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_ChargedSpear_Projectile=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_ChargedSpear_Projectile
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.ysortable=true
		self.expirytime=self.environment.localtime+2.5
	end	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_ChargedSpear_Drawable.new()
		self.drawable:Setup(self,self.environment)
	end
end
do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_ChargedSpear_Drawable=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_ChargedSpear_Drawable
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false
		self.modelfileid=2352157	--"nazjatar_weaponspear01"
		self.scale3D=0.5	--TODO: probably move to modelinfo
		self.positionmultiplier=0.61/0.5	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.61	--TODO: move to modelinfo	
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end
