do
	local super=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Azshara_Mobile
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Tidemistress_Mobile=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Tidemistress_Mobile
	function class:GetName()
		--override, don't call super
		return "Tidemistress (mobile) "..tostring(self.id)
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Tidemistress_Drawable.new()
		self.drawable:Setup(self,self.environment)		
	end
end

do
	if(not TRAININGGROUNDS_ModelInfos.Tidemistress)then
		local mi
		mi=TRAININGGROUNDS_ModelInfo.new()
		mi:Setup()		
		mi.displayid=91727 	-- Scarscale
		-- TODO: also displayid 91726 (Venomtongue)
		TRAININGGROUNDS_ModelInfos.Tidemistress=mi
		TRAININGGROUNDS_ModelInfos:Add(mi.displayid,mi)
	end
	local super=TRAININGGROUNDS_Drawable_CharacterModel
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Tidemistress_Drawable = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_Tidemistress_Drawable	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.scale3D=2
		self.positionmultiplier=1/2
		self.camerapositionmultiplier=1
	end	
	function class:SetFrameAppearance()	
		self.modelinfo=TRAININGGROUNDS_ModelInfos.Tidemistress
		self.frame:SetDisplayInfo(self.modelinfo.displayid)	
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end	
end


do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_CrystallineShield_Decor=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_CrystallineShield_Decor
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.ysortable=true
	end	
	function class:GetName()
		--override, don't call super
		return "Crystalline Shield (decor) "..tostring(self.id)
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_CrystallineShield_Drawable.new()
		self.drawable:Setup(self,self.environment)		
	end
end
do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_CrystallineShield_Drawable=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_CrystallineShield_Drawable
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false
		self.modelfileid=1007493	--"Arcane_shield_state_base_pink"
		self.scale3D=1.5	--TODO: probably move to modelinfo
		self.positionmultiplier=0.61/1.5	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.61	--TODO: move to modelinfo		
		self.zsortoffset3D=0.05	--measured in yards
		self.defaultanimation=158
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end

do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_CrystallineShieldExplosion_Decor=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_CrystallineShieldExplosion_Decor
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.ysortable=true
		self.expirytime=self.environment.localtime+0.7
	end	
	function class:GetName()
		--override, don't call super
		return "Crystalline Shield (decor) "..tostring(self.id)
	end
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_CrystallineShieldExplosion_Drawable.new()
		self.drawable:Setup(self,self.environment)		
	end
end
do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_CrystallineShieldExplosion_Drawable=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_QUEENAZSHARA_CHARGEDSPEAR_CrystallineShieldExplosion_Drawable
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false
		self.modelfileid=1604308	--"arcaneexplosion_castworld"
		self.scale3D=1	--TODO: probably move to modelinfo
		self.positionmultiplier=0.61/1	--TODO: move to modelinfo
		self.camerapositionmultiplier=0.61	--TODO: move to modelinfo		
		self.zsortoffset3D=0.05	--measured in yards
		--self.defaultanimation=158
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end