
do
	local super=TRAININGGROUNDS_Spell_SampleInstantAttack
	TRAININGGROUNDS_SIVARA_Spell_CrushingReverberation = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SIVARA_Spell_CrushingReverberation

	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		
		self.basecastduration=2.0
		
		self.iconshorthand="spell_nature_earthquake"
		
		self.range=nil	--TODO: make range=nil baseline?
	end
	
	--TODO 8.2: casting animations
	
	function class:ExecuteSpellEffect(projectile)		
		local bosscontroller=self.castercombat.owner.bosscontroller		
		if(not bosscontroller)then error("Assertion failed: CrushingReverberation's caster must have a BossController") end
		local groupdancemodule=bosscontroller.groupdancemodule				
		if(not groupdancemodule)then error("Assertion failed: CrushingReverberation's caster's BossController must have a GroupDanceModule") end
		
		local castermob=self.castercombat.owner
		for i=1,#groupdancemodule.raid.players do
			local player=groupdancemodule.raid.players[i]
			local angle=math.atan2(player.y-castermob.y,player.x-castermob.x)
			player.xspeed=math.cos(angle)*yard*15
			player.yspeed=math.sin(angle)*yard*15
			player.zspeed=yard*15
			if(player.z<=0)then player.z=1 end
			--print("TODO: Knockback on player",groupdancemodule.raid.players[i])
		end
		
		if(groupdancemodule.currenttankindex==1)then
			groupdancemodule.currenttankindex=2
		else
			groupdancemodule.currenttankindex=1
		end
		
		
		--groupdancemodule:ReactToCustomDanceEvent({action=TRAININGGROUNDS_SIVARA_CustomDanceEventType.CRUSHINGREVERBERATION_CLEAVE,subject=self:Class(),targets=targetlist})
		
	end

end