do
	local super=TRAININGGROUNDS_Mobile
	TRAININGGROUNDS_SIVARA_Mobile_Sivara=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SIVARA_Mobile_Sivara

	function class:GetName()
		--override, don't call super
		return "Sivara (mobile) "..tostring(self.id)
	end
	

	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		
		--self.TEMP_TAG=true
		
		self.nameplatename="Sivara"
		self.basemovespeed = 1.5 * TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(7.0)
		self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*10.0
		--self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*4.0
		--self.hitboxradius=TRAININGGROUNDS_Mobile_StandardHitboxRadius*3.0
		--self.baseturnspeed=2.0	
		--self.baseturnspeed_3D=2.0	
		self.faction=TRAININGGROUNDS_Factions.ENEMY
		
		--set after calling setup: 
		self.groupdancemodule=nil	-- (used when spells create further objects)		
	end
	
	function class:CreateAI()
		self.ai=TRAININGGROUNDS_AI_Boss.new()
		self.ai:Setup(self,environment)
	end		
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_SIVARA_Drawable_Sivara.new()
		self.drawable:Setup(self,self.environment)
	end
	
	-- function class:CreateCombatModule()
		-- self.combat=TRAININGGROUNDS_SIVARA_CombatModule_Sivara.new()
		-- self.combat:Setup(self)
	-- end
end

do
	--TODO: move to content/aggramar
	TRAININGGROUNDS_SIVARA_ANIMATION_LIST={}


	-- local stand=TRAININGGROUNDS_AnimationSequence_QuickSetup(TRAININGGROUNDS_SIVARA_ANIMATION_LIST,"Stand",0,nil,TRAININGGROUNDS_ANIMATION_PRIORITY.TELEGRAPH,nil)	
	-- local stance=TRAININGGROUNDS_AnimationSequence_QuickSetup(TRAININGGROUNDS_SIVARA_ANIMATION_LIST,"Stance",51,nil,TRAININGGROUNDS_ANIMATION_PRIORITY.TELEGRAPH,nil)
	-- local loop=TRAININGGROUNDS_AnimationSequence_QuickSetup(TRAININGGROUNDS_SIVARA_ANIMATION_LIST,"Sivara",125,nil,TRAININGGROUNDS_ANIMATION_PRIORITY.TELEGRAPH,nil)
	


	if(not TRAININGGROUNDS_ModelInfos.Sivara)then
		local mi
		mi=TRAININGGROUNDS_ModelInfo.new()
		mi:Setup()
		--mi.displayid=79568	--PH
		mi.displayid=92023
		--mi.cameradistance=15	--PH
		mi.cameradistance=30
		mi.cameratargetz=2
		mi.size=300

		mi.shadowsize=mi.size*0.75
		
		mi.clickboxx=0
		mi.clickboxy=-5
		mi.clickboxwidth=60
		mi.clickboxheight=80
		
		TRAININGGROUNDS_ModelInfos.Sivara=mi
		TRAININGGROUNDS_ModelInfos:Add(mi.displayid,mi)
	end

	local super=TRAININGGROUNDS_Drawable_CharacterModel
	TRAININGGROUNDS_SIVARA_Drawable_Sivara = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_SIVARA_Drawable_Sivara 
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.scale3D=1.5	--TODO: move to modelinfo
		--self.positionmultiplier=0.9
		self.positionmultiplier=1/self.scale3D
	end
	
	function class:SetFrameAppearance()	
		self.modelinfo=TRAININGGROUNDS_ModelInfos.Sivara
		self.frame:SetDisplayInfo(self.modelinfo.displayid)	
	end
	
	-- function class:Get3DPositionCoords()
		-- local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
		-- return self.x,self.y,self.z+yard*0.25
	-- end
end