do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_STORMWALLBLOCKADE_Decor_EnergizedStorm=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Decor_EnergizedStorm
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.ysortable=true
		self.alivetime=0
	end

	function class:GetName()
		--override, don't call super
		return "EnergizedStorm (decor) "..tostring(self.id)
	end
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_STORMWALLBLOCKADE_Drawable_EnergizedStorm.new()
		self.drawable:Setup(self,self.environment)		
	end

	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		if(self.alivetime>12.0)then
			self:Die()
		end
	end
	
end

do


	if(not TRAININGGROUNDS_ModelInfos.EnergizedStorm)then
		local mi
		mi=TRAININGGROUNDS_ModelInfo.new()
		mi:Setup()
		mi.displayid=67384
		--mi.cameradistance=80
		mi.cameradistance=40
		mi.size=500
		TRAININGGROUNDS_ModelInfos.EnergizedStorm=mi
		TRAININGGROUNDS_ModelInfos:Add(mi.displayid,mi)
	end

	local super=TRAININGGROUNDS_Drawable_CharacterModel
	TRAININGGROUNDS_STORMWALLBLOCKADE_Drawable_EnergizedStorm = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Drawable_EnergizedStorm 
	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
	
	function class:SetFrameAppearance()	
		self.modelinfo=TRAININGGROUNDS_ModelInfos.EnergizedStorm
		self.frame:SetDisplayInfo(self.modelinfo.displayid)	
	end

end