
do
	local super=TRAININGGROUNDS_Scenario
	TRAININGGROUNDS_STORMWALLBLOCKADE_Scenario_StormsWail = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Scenario_StormsWail

	local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)
	
	function class:Populate()
		super.Populate(self)				
			
			
		--TODO: RaidMarkerController should be in baseline scenario class	
		local wmcontroller=TRAININGGROUNDS_RaidMarkerController.new()
		wmcontroller:Setup(self.environment.game.environment_gameplay)
		self.wmcontroller=wmcontroller

		--print("Scenario.raid:",self.raid)

		local platformsize=yard*40
		
		--TODO: arenaborder should be in baseline scenario class
		local rect=TRAININGGROUNDS_Sprite.new()
		rect:Setup(self.environment.game.environment_gameplay)
		rect.drawable.ystretch=true
		rect.drawable.width=platformsize+20
		rect.drawable.height=platformsize+20
		rect.x=0;rect.y=0-10
		rect.drawable.frame.texture:Show()
		rect.drawable.frame.texture:SetColorTexture(1,1,1,1)
		rect.drawable.framelayer=self.environment.game.environment_gameplay.cameramanager.floorframelayer
		local rect=TRAININGGROUNDS_Sprite.new()
		rect:Setup(self.environment.game.environment_gameplay)
		rect.drawable.ystretch=true
		rect.drawable.width=platformsize*.75+20
		rect.drawable.height=platformsize+20
		rect.x=0;rect.y=-yard*40-10
		rect.drawable.frame.texture:Show()
		rect.drawable.frame.texture:SetColorTexture(1,1,1,1)
		rect.drawable.framelayer=self.environment.game.environment_gameplay.cameramanager.floorframelayer
		local rect=TRAININGGROUNDS_Sprite.new()
		rect:Setup(self.environment.game.environment_gameplay)
		rect.drawable.ystretch=true
		rect.drawable.width=platformsize
		rect.drawable.height=platformsize
		rect.x=0;rect.y=0
		rect.drawable.frame.texture:Show()
		rect.drawable.frame.texture:SetColorTexture(.1,.1,.1,1)
		rect.drawable.framelayer=self.environment.game.environment_gameplay.cameramanager.floorframelayer
		local rect=TRAININGGROUNDS_Sprite.new()
		rect:Setup(self.environment.game.environment_gameplay)
		rect.drawable.ystretch=true
		rect.drawable.width=platformsize*.75
		rect.drawable.height=platformsize
		rect.x=0;rect.y=-yard*40
		rect.drawable.frame.texture:Show()
		rect.drawable.frame.texture:SetColorTexture(.1,.1,.1,1)
		rect.drawable.framelayer=self.environment.game.environment_gameplay.cameramanager.floorframelayer		
		
		wmcontroller:PlaceWorldMarker(1,-platformsize/2+yard*5,yard*5)
		wmcontroller:PlaceWorldMarker(4,-platformsize/2+yard*5,platformsize-yard*5)
		
		
		
		
		self:CreateBossController()
		
		
		local currentplayer=self.raid.rdps[1]
		self.controls:SetPlayer(currentplayer)
		currentplayer:SetPlayerAppearance()
		local relevant=TRAININGGROUNDS_Aura_PlayerControlled.new()
		relevant:Setup(currentplayer.combat,currentplayer.combat,currentplayer:GetLocalTime())			

		self.stormswail.groupdancemodule:GetIntoInitialPosition()
		
		
		self.startbuttons={}
		--!!!
		local startbutton
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2-125
		startbutton.y=self.environment.game.window.frame:GetHeight()/4
		startbutton.drawable.width=200;startbutton.drawable.height=140
		startbutton:SetText("Use\rhint arrows")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self.stormswail.groupdancemodule.mode_choice=1									
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)
		
		startbutton=TRAININGGROUNDS_Button.new()
		startbutton:Setup(self.environment.game.environment_hud)
		startbutton.x=self.environment.game.window.frame:GetWidth()/2+125
		startbutton.y=self.environment.game.window.frame:GetHeight()/4
		startbutton.drawable.width=200;startbutton.drawable.height=140				
		startbutton:SetText("Don't use\rhint arrows")
		startbutton.drawable.frame:SetScript("OnClick",function()
					self.stormswail.groupdancemodule.mode_choice=2									
					self:OnStartButton()
				end)
		tinsert(self.startbuttons,startbutton)
		
	
		
		--dubious
		self.stormswail.groupdancemodule:StartDancing()
	end
	
	function class:CreateBossController()
		self.stormswail=TRAININGGROUNDS_STORMWALLBLOCKADE_BossController_StormsWail.new()
		--TODO: at this point it becomes very awkward that scenario.environment is not scenario.environment_gameplay
		self.stormswail:Setup(self.environment.game.environment_gameplay,self)
		self.stormswail:CreateBoss()		
		self.stormswail.groupdancemodule.bosscontroller=self.stormswail
		self.stormswail.groupdancemodule:PopulateDefaultRaid(self.environment.game.environment_gameplay)
	end
	
	function class:OnStartButton()
		for i=1,#self.startbuttons do
			self.startbuttons[i].visible=false	
			self.startbuttons[i].drawable.frame:EnableMouse(false)
		end
		self.stormswail.groupdancemodule:StartTestCycle()
	end
	
	function class:ShowButtons()
		for i=1,#self.startbuttons do
			self.startbuttons[i].visible=true	
			self.startbuttons[i].drawable.frame:EnableMouse(true)
		end	
	end

	--phase3all scenario inherits this one, so we only have to write this function once here:
	function class:OnEscapeKey()
		--TODO: cancelcountdown properly
		TRAININGGROUNDS_FakeDBM_CancelCountdown(DBM)
		self.environment.game:LoadScenarioByClass(TRAININGGROUNDS_Scenario_Menu)
	end
	
end