local yard=TRAININGGROUNDS_Mobile_ConvertYardsToTGUnits(1)

do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_STORMWALLBLOCKADE_WarlockGate=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_WarlockGate
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.alivetime=0
		self.state=1
		--must set groupdancemodule after calling setup for hit detection to work
		self.groupdancemodule=nil
		self.ysortable=true
	end
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_STORMWALLBLOCKADE_Drawable_WarlockGate.new()		
		self.drawable:Setup(self,self.environment)
	end
	
	function class:Step(elapsed)
		super.Step(self,elapsed)
		self.alivetime=self.alivetime+elapsed
		if(self.y>0)then
			if(self.groupdancemodule)then
				--print("Time check:",self.groupdancemodule.scenario.localtime,self.groupdancemodule.stormswailendtime)
				if(self.groupdancemodule.scenario.localtime<=self.groupdancemodule.stormswailendtime)then
					if(self.groupdancemodule.scenario.localtime+5.0>=self.groupdancemodule.stormswailendtime)then
						local player=self.groupdancemodule.player
						if(player.z==0)then
							local distsqr=(self.x-player.x)*(self.x-player.x)+(self.y-player.y)*(self.y-player.y)
							if(distsqr<=(yard*3)*(yard*3))then
								player.x=self.x
								player.y=self.y
								player.z=1
								player.zspeed=yard*11.7
								player.xspeed=0
								player.yspeed=-yard*70
							end
						end
					end
				end
				self.hitdetect=false
			end
		end
	end
end

do
	local super=TRAININGGROUNDS_Drawable_SpellEffect
	TRAININGGROUNDS_STORMWALLBLOCKADE_Drawable_WarlockGate=TRAININGGROUNDS_inheritsFrom(super)	
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Drawable_WarlockGate	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.anchor="CENTER"
		self.selected=false						
		self.modelfilename="spells/warlock_demonicportal_green.m2"
		self.modelfileid=607277
		self.defaultanimation=0	
		self.camera2Dlocation={-23,0,23*.707}	--TODO: use camera ystretch
			-- must point at -1, not 0, or else telegraph will appear too low on screen
		self.camera2Dtarget={0,0,-1}			
	end	
	function class:SetFrameAppearance()
		super.SetFrameAppearance(self)
		self.modelinfo.size=250
	end	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end
end