do
	local super=TRAININGGROUNDS_GameObject
	TRAININGGROUNDS_STORMWALLBLOCKADE_Decor_Katherine=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Decor_Katherine
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.ysortable=true
	end
	
	function class:GetName()
		--override, don't call super
		return "Katherine (decor) "..tostring(self.id)
	end
	
	function class:CreateAI()
		self.ai=TRAININGGROUNDS_AI_Boss.new()
		self.ai:Setup(self,environment)
	end		
	
	function class:SetDrawable()
		self.drawable=TRAININGGROUNDS_STORMWALLBLOCKADE_Katherine_Drawable.new()
		self.drawable:Setup(self,self.environment)		
	end
	
end

do
	if(not TRAININGGROUNDS_ModelInfos.Katherine)then
		local mi
		mi=TRAININGGROUNDS_ModelInfo.new()
		mi:Setup()
		mi.displayid=89304
		--mi.cameradistance=80
		--mi.cameradistance=40
		--mi.size=1000
		TRAININGGROUNDS_ModelInfos.Katherine=mi
		TRAININGGROUNDS_ModelInfos:Add(mi.displayid,mi)
	end

	local super=TRAININGGROUNDS_Drawable_CharacterModel
	TRAININGGROUNDS_STORMWALLBLOCKADE_Katherine_Drawable = TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_STORMWALLBLOCKADE_Katherine_Drawable 
	
	function class:SetCustomInfo()
		super.SetCustomInfo(self)
		self.scale3D=2
		self.positionmultiplier=1/2
	end
	
	function class:SetFrameAppearance()	
		self.modelinfo=TRAININGGROUNDS_ModelInfos.Katherine
		self.frame:SetDisplayInfo(self.modelinfo.displayid)	
	end
	
	function class:SetFrameLayer()
		self.framelayer=self.owner.environment.cameramanager.ysortframelayer
	end	
end
