
--TODO: move to Miscellaneous?
--TODO: since SelectionRectangle expects a ScenarioPlayerControls, enforce it during setup

--TODO: this is a mess, especially:
	-- 1. environment_gameplay/environment_hud storage
	-- 2. converting coordinates between the two

do
	local super=TRAININGGROUNDS_SelectionRectangle
	TRAININGGROUNDS_Selection_ClickOnly=TRAININGGROUNDS_inheritsFrom(super)
	local class=TRAININGGROUNDS_Selection_ClickOnly 

	--TODO LATER: can we change this inheritance pattern to :Setup(self,...) instead?
	function class:Setup(environment_hud,environment_gameplay)
		super.Setup(self,environment_hud,environment_gameplay)
		
		--list of objects that were "selected" when mouse was pressed (if selection worked that way)
		self.objs1={}
	end
	
	function class:OnPressMouseButton()
		--don't forget that self.environment is UI, not gameplay!

		--TODO: single-frame click can cause released to be called before pressed,
		-- at which point we crash because gamex,gamey, etc don't exist yet.
		-- initialize them in setup
		
		--TODO: move selection code to separate function in scenarioplayercontrols.lua
			-- and just send the list of highlighted objects to that function instead
		local env=self.environment.game.environment_gameplay
		local camera=env.camera	
		local frame=self.environment.game.window.frame		
				
		--TODO: camera position (screen scroll) not accounted for 
		--	(maybe don't need to?)
		local x3,y3=self.gamex,self.gamey
		local x4,y4=x3+self.gamewidth,y3+self.gameheight
		
		--for an object to count as clicked-on, the player must press AND release the mouse button within range
		--TODO: first check occurs when player PRESSES button, not RELEASES it
			-- (save object list between checks)
		self.objs1=self.environment:GetObjectsAtRectangleWindowCoordinates(env.mobiles,x3-1,y3-1,3,3)
		--local objs2=env:GetObjectsAtRectangleWindowCoordinates(env.mobiles,x4-1,y4-1,3,3)		
	end
	
	function class:OnReleaseMouseButton()
	
	
		--don't forget that self.environment is UI, not gameplay!
	
			--TODO: single-frame click can cause released to be called before pressed,
			-- at which point we crash because gamex,gamey, etc don't exist yet.
			-- initialize them in setup
		
		--TODO: move selection code to separate function in scenarioplayercontrols.lua
			-- and just send the list of highlighted objects to that function instead
		local env=self.environment.game.environment_gameplay
		local camera=env.camera	
		local frame=self.environment.game.window.frame		
				
		--TODO: camera position (screen scroll) not accounted for 
		--	(maybe don't need to?)
		
		-- the corners of the rectangle (x3,y3 is always < x4,y4)
		local x3,y3=self.gamex,self.gamey
		if((not self.gamex) or (not self.gamey))then 
			-- must check for gamex/gamey before continuing -- chance of crash if we load scenario while holding mouse button
			return 
		end
		local x4,y4=x3+self.gamewidth,y3+self.gameheight
		
		-- the actual position of the mouse cursor, regardless of what corner of the rectangle it's on
		local x5,y5=self.gamex2,self.gamey2	
		
		local totalselected=0
		
		--for an object to count as clicked-on, the player must press AND release the mouse button within range
		--TODO: first check occurs when player PRESSES button, not RELEASES it
			-- (save object list between checks)
		--local objs1=self.environment:GetObjectsAtRectangleWindowCoordinates(env.mobiles,x3-1,y3-1,3,3)
		--local objs2=env:GetObjectsAtRectangleWindowCoordinates(env.mobiles,x4-1,y4-1,3,3)
		local objs2=env:GetObjectsAtRectangleWindowCoordinates(env.mobiles,x5-1,y5-1,3,3)
		
		local objs=TRAININGGROUNDS_Set_Intersection(self.objs1,objs2)
		
		--TODO: we need to do something like self.playercontrols:FilterSelectedObjects
		-- but at the time this comment was written, we haven't decided what should be responsible for keeping track of playercontrols
																				--syntax: (self, player, objs)
		objs=TRAININGGROUNDS_ScenarioPlayerControls_CharacterMode.FilterSelectableObjectList(nil,nil,objs)
		
		
		--local objs=objs2	--!!!
	
		--TODO: ysort
		for i=1,#env.mobiles,1 do
			env.mobiles[i].TEMP_SelectedByCursor=false
		end
		local clicked_on_something=false
		for i=1,#objs,1 do
			objs[i].TEMP_SelectedByCursor=true
			clicked_on_something=true
			break
		end
		--TODO LATER: "and sticky_targeting==true"
		if(clicked_on_something)then
			for i=1,#env.mobiles,1 do
				env.mobiles[i]:Select(env.mobiles[i].TEMP_SelectedByCursor)	
			end
		end
		
		--self.environment.game.scenario.controls:CreateSpellButtonsFromSelectedUnits()
		
		--self.frame:SetParent(self.parentframe)
		--print("Select:",self.hudx,self.hudy,self.hudwidth,self.hudheight)
		
		--TODO: once camera_hud is fixed, we shouldn't need to hide frame here (setting visible false should be enough)
		self.drawable.frame:Hide()
		self.visible=false
	end

end